<?php 
if(file_exists('install/install.lock')) { 
    header('Location: ./install/index.php'); 
    exit;
}
include_once 'functions/control.php'; 
include_once 'functions/user.php';  
$DotOut = new DOT_USER($db); 
$page_Lang =  $DotOut->Dot_Languages();
$siteConfigurations = $DotOut->Dot_Configurations();
$siteTitle = $siteConfigurations['script_title'];
$siteLogo = $siteConfigurations['script_logo'];
$siteName = $siteConfigurations['script_name'];
$maintenance = $siteConfigurations['maintenance_mode'];
$wellcomeTheme = $siteConfigurations['wellcome_theme'];
$DefaultLang = 'english';
if(isset($_GET['lang'])){ 
   $DefaultLang = mysqli_real_escape_string($db, $_GET['lang']);
} 
?> 
<!DOCTYPE html>
<html>
<head>
    <!--==================== Title Start ====================-->
	<title><?php echo $siteTitle;?></title>
    <!--==================== Title Finish ====================-->
	<!--==================== Meta Tags Start ====================-->
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1, maximum-scale=1">
	<!--==================== Meta Tags Finish ====================-->
	<!--==================== Links Area Start ====================-->
	<link rel="stylesheet" type="text/css" href="<?php echo $base_url;?>wellcome_themes/<?php echo $wellcomeTheme;?>/css/style.css">
	<link rel="stylesheet" type="text/css" href="<?php echo $base_url;?>wellcome_themes/<?php echo $wellcomeTheme;?>/css/animate.min.css">
    <link rel="stylesheet" type="text/css" href="<?php echo $base_url;?>wellcome_themes/<?php echo $wellcomeTheme;?>/css/aos.css">
	<!--==================== Links Area Finish ====================-->
	<!--==================== Script Area Start====================-->
	<script type="text/javascript" src="<?php echo $base_url;?>/js/jquery-3.3.1.min.js"></script>
    <script type="text/javascript" src="<?php echo $base_url;?>wellcome_themes/<?php echo $wellcomeTheme;?>/js/oben.js"></script>  
    <script type="text/javascript" src="<?php echo $base_url;?>wellcome_themes/<?php echo $wellcomeTheme;?>/js/wellcome.js"></script>
    <script type="text/javascript" src="<?php echo $base_url;?>wellcome_themes/<?php echo $wellcomeTheme;?>/js/aos.js"></script>
    <script type="text/javascript" src="<?php echo $base_url;?>wellcome_themes/<?php echo $wellcomeTheme;?>/js/jQuery-face-cursor.js"></script>
    <!--==================== Script Area Finish ====================-->
    <script type="text/javascript">
	 var siteurl = '<?php echo $base_url;?>'; 
	 var u_alreadyinuse= '<?php echo $page_Lang['username_already_in_use'][$DefaultLang];?>';
	 var e_alreadyinuse= '<?php echo $page_Lang['email_already_in_use'][$DefaultLang];?>';
	</script>
</head>
<body>
	<!--================== Login Area Start =======================-->
    <div class="login_container">
      <div class="login_form_container" id="login_form_container">
        <div class="close_login"><div class="login_icon close_icon"></div></div>
        <div class="login">
          <div class="login_logo"><?php echo $siteName;?></div>
          <form class="login-form" enctype="multipart/form-data" method="post" id='loginform'>
          <div class="login_input">
            <div class="login_icon username_icon"></div> 
            <input type="text" class="logi_input username wellcome_input first" name="login_username" id="username" placeholder="<?php echo $page_Lang['username'][$DefaultLang];?>" />
          </div>
          <div class="login_input">
            <div class="login_icon password_icon"></div>
            <input type="password" class="logi_input password wellcome_input last" name="login_password" id="password" placeholder="<?php echo $page_Lang['password'][$DefaultLang];?>" /> 
          </div>
          <div class="loginss_button"> 
            <button type="submit" name="submit" class="logins_buton submit_btn snd" id='login_submit'><?php echo $page_Lang['login'][$DefaultLang];?></button>
          </div>
          </form>
        </div>
      </div>
    </div>
    <div class="wrapper"></div>
	<!--================== Login Area Finish =======================-->
    <!--================== Register Area Start =======================-->
    <div class="register_container">
      <div class="register_form_container" id="register_form_container">
        <div class="close_register"><div class="login_icon close_icon"></div></div>
        <div class="register">
          <div class="reg_logo"><?php echo $siteName;?></div>
          <form class="register-form" method="POST" id='registerform'>
          <div class="register_input">
            <div class="login_icon username_icon"></div> 
            <input type="text" name="reusername" id="register_username" class="regis_input i_nfrm numeric b_u" placeholder="<?php echo $page_Lang['username'][$DefaultLang];?>" />
          </div>
          <div class="register_input">
            <div class="login_icon fullname_icon"></div> 
            <input type="text" name="fullname" id="reg_fullname" class="regis_input i_nfrm fullname" placeholder="<?php echo $page_Lang['full_name'][$DefaultLang];?>" />
          </div>
          <div class="register_input">
            <div class="login_icon email_icon"></div> 
            <input type="text" class="regis_input i_nfrm icon_email" name="regemail" id="reg_email" placeholder="<?php echo $page_Lang['email'][$DefaultLang];?>" />
          </div>
          <div class="register_input">
            <div class="login_icon password_icon"></div> 
            <input type="password" name="password" class="regis_input password i_nfrm u_password" id="reg_password" placeholder="<?php echo $page_Lang['password'][$DefaultLang];?>" autocomplete="new-password" />
          </div>
                <div class="date">
              <div class="day">
                <select name="birth_day" id="subscription_day">
                      <option value=""><?php echo $page_Lang['day'][$DefaultLang];?></option>
                        <?php
                           $strDay='';
                           for ($i=1; $i<=31; $i++) {
                              $strDay=(string)$i;
                              if($i<10) $strDay='0'.$strDay;
                       ?> 
                       <option value="<?php echo $i; ?>">
                           <?php echo $strDay; ?>
                       </option>
                       <?php } ?>
                    </select>
              </div>
              <div class="month">
                <select name="birth_month" id="subscription_month">
                        <option value=""><?php echo $page_Lang['month'][$DefaultLang];?></option>
                        <?php
                           function getMonthList() {
                             return array( "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
                           }
                           $list=getMonthList();
                           $index=1;
                           foreach ( $list as &$row_data ) {
                        ?> <option value="<?php echo $index; ?>">
                        <?php echo $row_data; ?>
                        </option>
                        <?php $index=$index+1; } ?>
                     </select>
              </div>
              <div class="year">
                <select name="birth_year" id="subscription_year">
                       <option value=""><?php echo $page_Lang['year'][$DefaultLang];?></option>
                       <?php  for ($i=1950; $i<date('Y'); $i++) { ?>
                       <option value="<?php echo $i; ?>">
                       <?php echo $i; ?>
                        </option>
                       <?php } ?>
                    </select>
              </div>
            </div>
             <div class="gender">
              <div class="global-input-wrapp" id="gender">
              <div class="i_bg">
                <input type="radio" class="with-gap" name="gender" id="man" value="male">
                <label for="man"><?php echo $page_Lang['male'][$DefaultLang];?></label>
              </div>
              <div class="i_bg">
                <input type="radio" class="with-gap" name="gender" id="female" value="female">
                <label for="female"><?php echo $page_Lang['female'][$DefaultLang];?></label>
              </div>
            </div>
            </div>
          <div class="register_button"> 
            <button id="register" class="regis_buton submit_btn snd" type="submit"><?php echo $page_Lang['register'][$DefaultLang];?></button>
          </div>
          </form>
        </div>
      </div>
    </div>
    <div class="wrapperr"></div>
    <!--================== Register Area Finish =======================-->
    <!--================== Container Area Start =======================-->
    <div class="container" >
      <div class="section_container">
        <div class="internal_container">
          <div class="logo"><?php echo $siteName;?></div>
          <div class="explanation"><?php echo $page_Lang['sign_in_to_impress_people'][$DefaultLang];?></div>
          <div class="butons_group">
            <div class="login_buton">
              <input type="submit" name="" value="<?php echo $page_Lang['login'][$DefaultLang];?>" class="login_butns">
            </div>
            <div class="login_buton">
              <input type="submit" name="" value="<?php echo $page_Lang['register'][$DefaultLang];?>" class="register_butns">
            </div>
          </div>
    
        </div>
      </div>
    </div>
    <!--================== Container Area Finish =======================-->
    <!--================== Section Features Start =======================-->
    <div class="section_features">
      <div class="section_center">
        <div class="section_caption">Great Features</div>
        <div class="section_text">Most User Features.</div>
        <div class="section_object" >
          <div class="information">
          <div class="box_area">
            <div class="icon icon_friends"></div>
            <div class="box_caption" ><?php echo $page_Lang['follow_users'][$DefaultLang];?></div>
            <div class="box_text"><?php echo $page_Lang['follow_users_description'][$DefaultLang];?></div>
          </div>
        </div>
        <div class="information">
            <div class="box_area">
            <div class="icon icon_like"></div>
            <div class="box_caption"><?php echo $page_Lang['like_posts'][$DefaultLang];?></div>
            <div class="box_text"><?php echo $page_Lang['like_posts_description'][$DefaultLang];?></div>
          </div>
        </div>
        <div class="information">
          <div class="box_area">
            <div class="icon icon_add"></div>
            <div class="box_caption"><?php echo $page_Lang['share_story'][$DefaultLang];?></div>
            <div class="box_text"><?php echo $page_Lang['share_story_description'][$DefaultLang];?></div>
          </div>
        </div>
        </div>
      </div>
    </div>
    <!--================== Section Feature Finish =======================-->
    <!--================== İnfo Section Start =======================-->
    <div class="info_section">
      <div class="info_general">
          <div class="info_mobile_front">
            <img src="<?php echo $base_url;?>wellcome_themes/<?php echo $wellcomeTheme;?>/css/images/phone_front.png">
          </div>
          <div class="info_mobile_back">
            <img src="<?php echo $base_url;?>wellcome_themes/<?php echo $wellcomeTheme;?>/css/images/phone_back.png">
          </div>
    
          <div class="info_right">
            <div class="info_square">
              <div class="icons_area">
              <div class="info_icon interest_icon"></div>
              </div>
               <div class="icons_area">
              <div class="info_caption">
                Share Your Interest On Your Profile
              </div>
              <div class="info_text">
              People wonder about your interests. Give them the opportunity to know you in advance. Who knows, perhaps the most important people in your life by learning this information will offer to you.
              </div>
            </div>
            </div>
             <div class="info_square">
              <div class="icons_area ">
              <div class="info_icon chat_icon"></div>
              </div>
               <div class="icons_area">
              <div class="info_caption">
                Chat With Your Friends
              </div>
              <div class="info_text">
                Enjoy instant chat with people you want to be friends or friends. All you have to do is write.
              </div>
            </div>
            </div>
             <div class="info_square">
              <div class="icons_area">
              <div class="info_icon filter_icon"></div>
              </div>
               <div class="icons_area ">
              <div class="info_caption">
                Make a Filtered Images
              </div>
              <div class="info_text">
                Upload an image and filter images with nice 10+ Instagram Style Filters. Make happy your followers with your filtered images.
              </div>
            </div>
            </div>
          </div>
      </div>
    </div>
    <!--================== İnfo Section Finish =======================-->
    <!--================== Property Section Start =======================-->
    <div class="property_section">
      <div class="general_property_section">
        <div class="left_text">
          <div class="left_caption" data-aos="fade-down"data-aos-easing="linear"data-aos-duration="600"><?php echo $page_Lang['share_anything_you_want'][$DefaultLang];?></div>
          <div class="left_article"  data-aos="fade-down"data-aos-easing="linear"data-aos-duration="800"><?php echo $page_Lang['share_six_post'][$DefaultLang];?></div>
          <hr class="line"></hr>
           <div class="rotate_area">
             <div class="posts_one" data-aos="fade-right" data-aos-easing="ease-in-sine" data-aos-duration="600">
              <div class="tick_icon"></div><div class="rotate_icon"></div>
              <div class="item_title"><?php echo $page_Lang['text_sharing'][$DefaultLang];?></div>
              <div class="item_title_description"><?php echo $page_Lang['text_sharing_info'][$DefaultLang];?></div>
            </div>
           </div>
            <div class="rotate_area">
             <div class="posts_one" data-aos="fade-right" data-aos-easing="ease-in-sine" data-aos-duration="700">
              <div class="tick_icon"></div><div class="rotate_icon"></div>
              <div class="item_title"><?php echo $page_Lang['audio_sharing'][$DefaultLang];?></div>
              <div class="item_title_description">By sharing your favorite music with your friends away.</div>
           </div>
           </div>
            <div class="rotate_area">
             <div class="posts_one" data-aos="fade-right" data-aos-easing="ease-in-sine" data-aos-duration="800">
              <div class="tick_icon"></div><div class="rotate_icon"></div>
              <div class="item_title"><?php echo $page_Lang['image_sharing'][$DefaultLang];?></div>
              <div class="item_title_description"><?php echo $page_Lang['image_sharing_info'][$DefaultLang];?></div>
            </div>
           </div>
            <div class="rotate_area">
             <div class="posts_one" data-aos="fade-right" data-a  os-easing="ease-in-sine" data-aos-duration="900">
              <div class="tick_icon"></div><div class="rotate_icon"></div>
               <div class="item_title"><?php echo $page_Lang['video_sharing'][$DefaultLang];?></div>
              <div class="item_title_description"><?php echo $page_Lang['share_video_info'][$DefaultLang];?></div>
            </div>
           </div>
            <div class="rotate_area">
             <div class="posts_one" data-aos="fade-right" data-aos-easing="ease-in-sine" data-aos-duration="1000">
              <div class="tick_icon"></div><div class="rotate_icon"></div>
               <div class="item_title"><?php echo $page_Lang['link_sharing'][$DefaultLang];?></div>
              <div class="item_title_description"><?php echo $page_Lang['link_share_info'][$DefaultLang];?></div>
            </div>
           </div>
           <div class="rotate_area">
             <div class="posts_one" data-aos="fade-right" data-aos-easing="ease-in-sine" data-aos-duration="1100">
              <div class="tick_icon"></div><div class="rotate_icon"></div>
              <div class="item_title"><?php echo $page_Lang['filter_sharing'][$DefaultLang];?></div>
              <div class="item_title_description"><?php echo $page_Lang['share_filter_info'][$DefaultLang];?></div>
            </div>
           </div>
        </div>
        <div class="property_right_area">
          <div class="round_area round_icon"></div>
          <div class="round_area round_icon"></div>
          <div class="round_area round_icon"></div>
          <div class="round_area round_icon"></div>
          <div class="round_area round_icon"></div>
          <div class="round_area round_icon"></div>
        </div>
      </div>
    </div>
    <!--================== Property Section Finish =======================-->
    <!--================== Four Section Start =======================-->
    <div class="four_section">
      <div class="four_bottom_field">
        <div class="left_boxes_area">
          <div class="inline_boxes">
            <div class="one_box">
              <div class="one_box_icon" data-aos="fade-down" data-aos-easing="linear" data-aos-duration="800"></div>
              <div class="one_box_caption" data-aos="fade-down" data-aos-easing="linear" data-aos-duration="800">Radar System</div>
              <div class="one_box_text" data-aos="fade-right" data-aos-easing="ease-in-sine" data-aos-duration="1000">We built the radar system so everyone could see what they shared. What you share reflects you and you are recognized and loved as much as you can reflect on yourself. That's exactly why the radar catches you and shows it to everyone so you can promote yourself better.</div>
            </div>
          </div>
        </div>
        <div class="right_radar_area">
          <div class="radar_chapter">
          <?php
			   $LatestUsers = $DotOut->Dot_LatestRegisteredUsers(5);
			  if($LatestUsers){
				 foreach($LatestUsers as $dataLatests){
				   $l_uid = $dataLatests['user_id'];
				   $l_userfulllname = $dataLatests['user_fullname'];
				   $l_Avatar = $DotOut->Dot_UserAvatar($l_uid, $base_url);  
					 echo '<div class="persons_chapter persons_icon" style="background-image:url('.$l_Avatar.');"></div>';
				 }
			  }
			 ?>     
          </div>
        </div>
      </div>
    </div>
    <!--================== Four Section Finish =======================-->
    <!--================== Footer Section Start =======================-->
     <div class="footer_chapter">
        <div class="footer_in">
            <a href="<?php echo $base_url;?>about-us" >About us</a>
            <a href="<?php echo $base_url;?>privacy-policies">Privacy Policies</a> 
        </div>
      </div>
    <!--================== Footer Section Finish =======================-->
    </body>
    </html>