<?php 
function get_ip_address() {
    if (!empty($_SERVER['HTTP_X_FORWARDED']) && validate_ip($_SERVER['HTTP_X_FORWARDED']))
        return $_SERVER['HTTP_X_FORWARDED'];
    if (!empty($_SERVER['HTTP_X_CLUSTER_CLIENT_IP']) && validate_ip($_SERVER['HTTP_X_CLUSTER_CLIENT_IP']))
        return $_SERVER['HTTP_X_CLUSTER_CLIENT_IP'];
    if (!empty($_SERVER['HTTP_FORWARDED_FOR']) && validate_ip($_SERVER['HTTP_FORWARDED_FOR']))
        return $_SERVER['HTTP_FORWARDED_FOR'];
    if (!empty($_SERVER['HTTP_FORWARDED']) && validate_ip($_SERVER['HTTP_FORWARDED']))
        return $_SERVER['HTTP_FORWARDED'];
    return $_SERVER['REMOTE_ADDR'];
}
function validate_ip($ip) {
    if (strtolower($ip) === 'unknown')
        return false;
    $ip = ip2long($ip);
    if ($ip !== false && $ip !== -1) {
        $ip = sprintf('%u', $ip);
        if ($ip >= 0 && $ip <= 50331647)
            return false;
        if ($ip >= 167772160 && $ip <= 184549375)
            return false;
        if ($ip >= 2130706432 && $ip <= 2147483647)
            return false;
        if ($ip >= 2851995648 && $ip <= 2852061183)
            return false;
        if ($ip >= 2886729728 && $ip <= 2887778303)
            return false;
        if ($ip >= 3221225984 && $ip <= 3221226239)
            return false;
        if ($ip >= 3232235520 && $ip <= 3232301055)
            return false;
        if ($ip >= 4294967040)
            return false;
    }
    return true;
} 
// Get User IP
//$ip = get_ip_address(); 
?>
<div class="poSBoxContainer">
   <div class="post-modal-Wrap">
       <div class="post-modal-middle">
           <!--header started-->
           <div class="post-modal-header">
               <div class="poster_avatar"><img src="<?php echo $dataUserAvatar;?>" class="a0uk"/></div> 
               <div class="poster_Name"><?php echo $dataUserFullName;?></div>
               <div class="posting_arrow"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="24" height="24" viewBox="0 0 192 192" style=" fill:#000000;"><g fill="none" fill-rule="nonzero" stroke="none" stroke-width="1" stroke-linecap="butt" stroke-linejoin="miter" stroke-miterlimit="10" stroke-dasharray="" stroke-dashoffset="0" font-family="none" font-weight="none" font-size="none" text-anchor="none" style="mix-blend-mode: normal"><path d="M0,192v-192h192v192z" fill="none"></path><g fill="#8a99a4"><path d="M104.568,96l-30.568,-30.568c-3.312,-3.312 -3.312,-8.688 0,-12v0c3.312,-3.312 8.688,-3.312 12,0l36.912,36.912c3.128,3.128 3.128,8.192 0,11.312l-36.912,36.912c-3.312,3.312 -8.688,3.312 -12,0v0c-3.312,-3.312 -3.312,-8.688 0,-12z"></path></g></g></svg></div>
               <div class="post_icons"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="30" height="30" viewBox="0 0 192 192" style=" fill:#000000;"><g fill="none" fill-rule="nonzero" stroke="none" stroke-width="1" stroke-linecap="butt" stroke-linejoin="miter" stroke-miterlimit="10" stroke-dasharray="" stroke-dashoffset="0" font-family="none" font-weight="none" font-size="none" text-anchor="none" style="mix-blend-mode: normal"><path d="M0,192v-192h192v192z" fill="none"></path><g fill="#8a99a4"><path d="M133.5,3c-22.8,0 -41.25,18.45059 -42,41.85059c-0.6,21.75 20.25117,50.39941 32.70117,65.39941c2.4,2.85 5.69883,4.35059 9.29883,4.35059c3.6,0 6.89883,-1.65059 9.29883,-4.35059c12.45,-15.15 33.45117,-43.64941 32.70117,-65.39941c-0.75,-23.4 -19.2,-41.85059 -42,-41.85059zM79.0957,11.42871c-0.31055,0.00762 -0.62754,0.04512 -0.94629,0.12012c-27,5.85 -49.19941,23.40117 -60.89941,48.45117c-9.75,21 -10.80059,44.70117 -2.85059,66.45117c7.95,21.75 23.85,39.29883 45,49.04883c11.7,5.4 24.15,8.25 36.75,8.25c10.05,0 20.10059,-1.8 29.85059,-5.25c21.9,-7.95 39.29883,-23.85 49.04883,-45c4.2,-9 6.75176,-18.45117 7.80175,-28.20117c0.3,-2.4 -1.50176,-4.64824 -4.05175,-4.94824c-2.4,-0.3 -4.64825,1.49883 -4.94825,4.04883c-0.9,8.7 -3.14942,17.25059 -6.89942,25.35059c-8.85,18.9 -24.45117,33.15059 -43.95117,40.35058c-19.5,7.05 -40.79883,6.14825 -59.54883,-2.55175c-2.85,-1.35 -5.55,-2.85 -8.25,-4.5c2.55,-0.15 5.24941,-0.9 7.64941,-2.25c2.7,-1.5 5.54824,-3.29942 8.69824,-5.39942c2.1,-1.5 3.9,-3.44825 5.25,-5.69824c1.5,-2.7 3.30117,-5.55058 4.20117,-8.85058c5.85,-22.5 -13.65,-23.40059 -14.25,-28.35059c-0.6,-5.55 6.60117,-9.75059 10.95117,-14.10059c4.35,-4.35 5.69824,-11.1 3.44824,-15c-7.2,-12.9 -24.29824,-6.15059 -25.94824,7.64941c-0.9,8.25 -5.85176,16.65 -10.05176,21c-4.2,4.2 -12.44824,1.95176 -14.69824,-4.19824c-2.55,-6.9 6.29824,-9.45176 4.94824,-18.30176c-0.3,-2.4 -2.85,-3.59883 -6,-4.04883l-10.35059,0.29883c1.05,-7.5 3.30059,-14.85 6.60059,-21.75c10.2,-22.65 30.15117,-38.39941 54.45117,-43.64942c2.4,-0.45 4.04824,-2.84941 3.44824,-5.39941c-0.39375,-2.1 -2.2793,-3.62461 -4.45312,-3.57129zM133.5,30c8.25,0 15,6.75 15,15c0,8.25 -6.75,15 -15,15c-8.25,0 -15,-6.75 -15,-15c0,-8.25 6.75,-15 15,-15z"></path></g></g></svg></div>
               <!--Select Feelings-->
               <div class="ch_feeling">
                   <svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="24" height="24" viewBox="0 0 172 172" style=" fill:#000000;"><g fill="none" fill-rule="nonzero" stroke="none" stroke-width="1" stroke-linecap="butt" stroke-linejoin="miter" stroke-miterlimit="10" stroke-dasharray="" stroke-dashoffset="0" font-family="none" font-weight="none" font-size="none" text-anchor="none" style="mix-blend-mode: normal"><path d="M0,172v-172h172v172z" fill="none"></path><g fill="#8a99a4"><path d="M86,14.33333c-39.5815,0 -71.66667,32.08517 -71.66667,71.66667c0,39.5815 32.08517,71.66667 71.66667,71.66667c39.5815,0 71.66667,-32.08517 71.66667,-71.66667c0,-39.5815 -32.08517,-71.66667 -71.66667,-71.66667zM111.08333,57.33333c5.94833,0 10.75,4.80167 10.75,10.75c0,5.94833 -4.80167,10.75 -10.75,10.75c-5.94833,0 -10.75,-4.80167 -10.75,-10.75c0,-5.94833 4.80167,-10.75 10.75,-10.75zM60.91667,57.33333c5.94833,0 10.75,4.80167 10.75,10.75c0,5.94833 -4.80167,10.75 -10.75,10.75c-5.94833,0 -10.75,-4.80167 -10.75,-10.75c0,-5.94833 4.80167,-10.75 10.75,-10.75zM86,125.41667c-14.56267,0 -27.219,-7.955 -34.02017,-19.68683c-1.38317,-2.3865 0.39417,-5.3965 3.14617,-5.3965h61.74083c2.75917,0 4.52933,3.01 3.14617,5.3965c-6.794,11.73183 -19.45033,19.68683 -34.013,19.68683z"></path></g></g></svg>
               </div>
               <!--Select Feelings-->
               <div class="who_see" id="who" data-who="1" data-see="everyone" data-position="left">
               <svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="24" height="24" viewBox="0 0 192 192" style=" fill:#000000;"><g fill="none" fill-rule="nonzero" stroke="none" stroke-width="1" stroke-linecap="butt" stroke-linejoin="miter" stroke-miterlimit="10" stroke-dasharray="" stroke-dashoffset="0" font-family="none" font-weight="none" font-size="none" text-anchor="none" style="mix-blend-mode: normal"><path d="M0,192v-192h192v192z" fill="none"></path><g fill="#8a99a4"><g id="surface1"><path d="M96,1.15385c-52.32692,0 -94.84615,42.51923 -94.84615,94.84615c0,52.32693 42.51923,94.84615 94.84615,94.84615c52.32693,0 94.84615,-42.51923 94.84615,-94.84615c0,-52.32692 -42.51923,-94.84615 -94.84615,-94.84615zM96,13.15385c15.63462,0 30.23077,4.26923 42.69231,11.76923c0.08654,0.0577 0.14423,0.17308 0.23077,0.23077c0.14423,0.14423 0.31731,0.31731 0.46154,0.46154c0.14423,0.17308 0.20192,0.11538 0.46154,0.23077c0.08654,0.40385 0.25961,0.69231 0.46154,0.92308c0.08654,0.08654 0.11538,0.28847 0.23077,0.46154c0.17308,0.23077 0.40385,0.49038 3,1.84615c-0.31731,-0.14423 -0.69231,-0.02884 -0.92308,0.23077c-0.11538,0.14423 -0.23077,0.28847 -0.23077,0.46154c-0.28846,-0.14423 -0.63461,-0.31731 -0.92308,-0.46154c-0.375,-0.14423 -0.54808,-0.28846 -0.92308,-0.46154c-0.05769,-0.02884 -0.17307,0.02884 -0.23077,0l-1.61538,-0.23077c-0.11538,-0.02884 -0.34615,-0.05769 -0.46154,0c-0.05769,0.02884 -0.17307,-0.02884 -0.23077,0l-0.92308,-0.23077l-0.92308,-0.46154c-0.05769,-0.02884 -0.40384,-0.23077 -0.46154,-0.23077l-1.38462,-0.23077c-0.05769,0 -0.17307,0 -0.23077,0h-0.92308c-0.14423,0 -0.34615,0.17308 -0.46154,0.23077c-0.14423,0.08654 -0.17307,0.08654 -0.23077,0.23077l-0.23077,0.46154l-0.69231,0.23077c-0.17307,0.02884 -0.34615,0.08654 -0.46154,0.23077c-0.05769,0.08654 -0.20192,0.34615 -0.23077,0.46154l-0.23077,0.23077c-0.11538,0.11538 -0.20192,0.31731 -0.23077,0.46154l-0.23077,0.46154c-0.08654,0.08654 -0.20192,0.34615 -0.23077,0.46154c-0.02884,0.08654 -0.02884,0.14423 0,0.23077v0.46154l-0.23077,2.76923c0,0.0577 -0.02884,0.14423 0,0.23077c-0.05769,0.02884 -0.17307,0.17308 -0.23077,0.23077l-1.38462,2.07692c-0.20192,0.23077 -0.40384,0.43269 -0.23077,0.69231l2.30769,3.46154l0.23077,0.69231c0.0577,0.11538 0.14423,0.14423 0.23077,0.23077c0.51923,0.43269 1.24039,0.57692 1.84615,0.69231c0.08654,0 0.14423,-0.02884 0.23077,0v1.15385c-0.02884,0.20192 0.08654,0.54808 0.23077,0.69231l0.46154,0.69231c0.02884,0.08654 0.17308,0.14423 0.23077,0.23077l-1.15385,0.46154c-0.08654,0.02884 -0.14423,-0.05769 -0.23077,0c-0.02884,0.02884 -0.20192,0.20192 -0.23077,0.23077l-0.46154,0.69231c-0.14423,0 -0.31731,0.11538 -0.46154,0.23077l-0.46154,0.46154c-0.05769,0.0577 -0.20192,0.17308 -0.23077,0.23077c-0.02884,0.02884 0.02884,0.20192 0,0.23077l-0.23077,0.46154v-0.69231c0,-0.02884 0,-0.20192 0,-0.23077c-0.05769,-0.34615 -0.02884,-0.34615 -4.15385,-4.15385v-0.92308c0,-0.05769 0,-0.40384 0,-0.46154l-0.23077,-0.23077c-0.02884,-0.05769 0.02884,-0.17307 0,-0.23077c-0.17307,-0.28846 -0.25961,-0.28846 -1.61538,-0.92308v-0.46154c-0.20192,-0.375 -0.66346,-0.43269 -1.15385,-0.46154h-0.92308c-0.72115,0.0577 -0.77885,0.17308 -1.38462,3.23077c0,0.11538 -0.05769,0.375 0,0.46154c0.02884,0.0577 -0.02884,0.17308 0,0.23077c-0.05769,0 -0.40384,0.20192 -0.46154,0.23077c-0.17307,0.02884 -0.31731,0.08654 -0.46154,0.23077c-0.05769,0.02884 -0.17307,-0.02884 -0.23077,0c-0.08654,0.0577 -0.02884,0.14423 -0.23077,0.23077c-0.05769,0.02884 -0.20192,-0.02884 -0.23077,0c-0.43269,0 -0.77885,0.28847 -1.38462,0.92308c-0.11538,0.17308 -0.05769,0.49038 0,0.69231l0.23077,0.92308c0.08654,0.23077 0.17308,0.25961 0.46154,0.46154c-0.05769,0.0577 -0.20192,0.20192 -0.23077,0.23077c-0.05769,0.08654 0.02884,0.14423 0,0.23077l-0.23077,1.15385c-0.02884,0.25961 0.0577,0.72115 0.23077,0.92308c0.14423,0.17308 0.43269,0.31731 0.92308,0.23077l2.07692,-0.46154c0.0577,-0.02884 0.20192,0.02884 0.23077,0l1.61538,-0.69231c0.02884,-0.02884 0.20192,0.02884 0.23077,0c0.02884,0.02884 -0.02884,0.20192 0,0.23077h-0.23077c-0.05769,0.0577 -0.17307,0.14423 -0.23077,0.23077c-0.02884,0.02884 0.02884,0.17308 0,0.23077l-0.46154,0.92308c-0.05769,0.25961 0.0577,0.69231 0.23077,0.92308c0.17308,0.23077 0.51923,0.43269 0.92308,0.46154h0.69231l-0.23077,0.69231c-0.02884,0.08654 0,0.14423 0,0.23077c0,0.0577 0,0.17308 0,0.23077c0.0577,0.28847 -0.05769,0.63462 0,0.92308c0.0577,0.11538 0.375,0.60577 0.46154,0.69231c0.14423,0.14423 0.25961,0.23077 0.46154,0.23077c0.46154,0.02884 0.77885,0 1.15385,0l1.61538,1.15385l-0.23077,0.46154c0,0.0577 0,0.40385 0,0.46154l0.23077,0.92308c-0.66346,-0.11538 -0.77885,-0.34615 -3.46154,-0.69231c-0.23077,-0.05769 -0.46154,-0.05769 -1.38462,-0.23077c-0.11538,-0.02884 -0.14423,-0.02884 -0.23077,0l-0.46154,0.23077c-0.20192,0.0577 -0.375,0.23077 -0.46154,0.46154c-0.05769,0.08654 0.0577,0.11538 0,0.23077h-0.46154c-0.17307,0.02884 -0.34615,0.31731 -0.46154,0.46154c-0.02884,0.02884 -0.17307,-0.05769 -0.23077,0c-0.14423,0.14423 -0.25961,0.49038 -0.23077,0.69231c0.14423,0.92308 0.31731,2.27885 0.46154,3.23077l-0.46154,2.53846c0,0.0577 0,0.17308 0,0.23077c0.02884,0.08654 -0.02884,0.23077 0,0.46154c0.02884,0.17308 0.08654,0.34615 0.23077,0.46154l0.46154,0.46154l0.69231,1.84615c0.17308,0.46154 0.66346,0.77885 1.15385,0.69231l1.38462,-0.23077l0.69231,0.46154l-4.61538,3.92308c-0.08654,0.0577 -0.20192,0.375 -0.23077,0.46154l-0.69231,3.23077l-3.23077,2.07692l-1.38462,0.69231c-0.17307,0.08654 -0.375,0.28847 -0.46154,0.46154c-0.60577,1.35577 -1.67307,2.94231 -2.53846,4.38462c-0.375,0.63462 -0.54808,1.18269 -0.92308,1.84615l-1.84615,3.69231c-0.05769,0.11538 -0.02884,0.34615 0,0.46154c0.02884,0.43269 0,0.46154 0,0.69231c0,0.11538 -0.05769,0.375 0,0.46154c0,0.02884 0.20192,0.20192 0.23077,0.23077l0.46154,0.69231l0.46154,3.46154l-2.30769,4.38462c-0.14423,0.25961 0,0.69231 0.23077,0.92308l0.92308,0.92308c0,0.43269 0.02884,0.92308 0,1.38462c-0.02884,0.08654 0,0.14423 0,0.23077v0.23077c0,0.14423 -0.08654,0.34615 0,0.46154l0.69231,1.15385l1.15385,1.15385l2.30769,3.23077c0.0577,0.08654 0.17308,0.17308 0.23077,0.23077l1.38462,1.15385l0.92308,1.38462c0.02884,0.02884 0.20192,-0.02884 0.23077,0l0.46154,0.23077c0.02884,0.02884 -0.02884,0.20192 0,0.23077l0.23077,0.23077c0.0577,0.0577 0.14423,-0.02884 0.23077,0l3.23077,1.84615l1.15385,0.92308c0.11538,0.08654 0.08654,0.20192 0.23077,0.23077c0.02884,0 0.17308,0 0.23077,0c0.51923,0 1.21154,-0.25961 1.61538,-0.46154l2.30769,-0.23077h3.69231c0.02884,0 0.20192,-0.23077 0.23077,-0.23077l3.46154,-0.23077c0.08654,0.02884 0.14423,0.02884 0.23077,0h0.46154c0.08654,-0.02884 0.17308,-0.17307 0.23077,-0.23077l1.38462,-0.69231h1.38462l0.92308,-0.23077l0.69231,2.07692c0.11538,0.31731 0.60577,0.51923 0.92308,0.46154h2.53846l0.92308,1.38462l0.23077,0.46154l-2.07692,4.15385c-0.08654,0.17308 -0.08654,0.28847 0,0.46154l1.84615,4.38462l0.23077,0.92308v0.92308c0,0.02884 0,0.23077 0,0.23077c0,0.11538 0.17308,0.14423 0.23077,0.23077c0.02884,0.11538 0.20192,0.34615 0.23077,0.46154c0.0577,0.11538 -0.02884,0.28847 0,0.46154l0.23077,0.46154l-0.46154,1.38462l-0.92308,5.07692l-1.61538,1.38462l-0.69231,1.84615l-0.46154,0.23077c-0.05769,0.02884 -0.40384,0.17308 -0.46154,0.23077c-0.11538,0.08654 -0.17307,0.11538 -0.23077,0.23077c-0.40384,0.98077 -0.80769,1.90385 -1.15385,2.76923c-0.02884,0.08654 0,0.375 0,0.46154c-0.02884,0.08654 -0.02884,0.14423 0,0.23077l0.46154,1.84615c-0.80769,3 -1.73077,6.23077 -2.53846,8.53846c-0.02884,0.02884 -0.23077,0.20192 -0.23077,0.23077v0.69231l-0.69231,1.61538c-0.28846,0.60577 -0.40384,0.83654 -0.92308,1.84615l-0.69231,0.69231c-0.43269,0.49038 -0.86538,1.24039 -1.15385,1.84615l-0.23077,0.46154c-0.11538,0.17308 -0.08654,0.25961 0,0.46154c0.08654,0.20192 0.25961,0.375 0.46154,0.46154c0.46154,0.17308 0.83654,0.23077 1.15385,0.23077c0.08654,0 0.14423,0.02884 0.23077,0c0.25961,-0.11538 0.63462,-0.28846 0.92308,-0.46154v-0.23077c1.21154,-0.23077 2.79808,-0.40384 4.15385,-0.69231l2.53846,-1.15385c0.0577,-0.02884 0.20192,-0.20192 0.23077,-0.23077l3.69231,-2.53846c0.02884,-0.02884 0.20192,0.02884 0.23077,0v-0.23077c0.46154,-0.31731 1.5577,-0.92308 1.84615,-1.15385l1.84615,-2.07692l0.92308,-0.92308l0.46154,-0.23077h0.46154c0.08654,0 0.14423,0.02884 0.23077,0c0.40385,-0.17307 0.66346,-0.66346 0.92308,-0.92308l2.30769,-2.30769c0.0577,-0.05769 0.20192,-0.17307 0.23077,-0.23077l1.38462,-2.53846l0.23077,-0.23077h0.23077c0.11538,0 0.14423,-0.17307 0.23077,-0.23077c0.40385,-0.17307 0.69231,-0.40384 0.92308,-0.69231l0.46154,-0.46154c1.03846,-0.72115 2.27885,-1.75961 3,-2.30769h0.23077c-0.11538,0.14423 -0.11538,0.28847 -0.23077,0.46154c-0.05769,0.0577 -0.20192,0.40385 -0.23077,0.46154l-0.92308,1.61538l-1.84615,1.61538c-0.14423,0.17308 -0.14423,0.17308 -2.53846,3.69231c-0.17307,0.31731 -0.20192,0.72115 -0.23077,1.15385c-0.02884,0.28847 0,0.54808 0.23077,0.69231c-15.02884,15.40385 -36.02884,24.92308 -59.30769,24.92308c-3.92308,0 -7.75961,-0.40384 -11.53846,-0.92308c0.08654,-0.17307 0.0577,-0.51923 0,-0.69231c0.11538,0.02884 0.34615,0.02884 0.46154,0c0.11538,-0.02884 0.14423,-0.17307 0.23077,-0.23077c0.14423,-0.11538 0.43269,-0.25961 0.46154,-0.46154c0.02884,-0.20192 -0.08654,-0.51923 -0.23077,-0.69231l-0.69231,-0.69231c-0.14423,-0.14423 -0.11538,-0.31731 -0.92308,-0.69231c-0.08654,-0.02884 -0.14423,0 -0.23077,0c-0.11538,-0.02884 -0.34615,0.17308 -0.46154,0.23077c-0.14423,0.0577 -0.34615,-0.05769 -0.46154,0c-0.28846,0.17308 -0.34615,0.60577 -0.23077,0.92308c0.02884,0.14423 0.11538,0.23077 0.23077,0.46154l-1.15385,-0.23077c-0.05769,-0.02884 -0.14423,-0.20192 -0.23077,-0.23077c-0.05769,-0.02884 -0.17307,0 -0.23077,0l-0.23077,-0.23077c-0.05769,-0.05769 -0.17307,-0.20192 -0.23077,-0.23077l-0.92308,-0.46154l-0.92308,-1.38462c-0.02884,-0.02884 -0.20192,-0.23077 -0.23077,-0.23077c-0.17307,-0.17307 -0.28846,-0.25961 -0.46154,-0.46154c-0.08654,-0.08654 -0.11538,-0.17307 -0.23077,-0.23077l-0.92308,-0.23077c0,-0.17307 -0.11538,-0.31731 -0.23077,-0.46154c-0.72115,-0.83654 -1.41346,-1.73077 -2.07692,-2.53846c-0.05769,-0.08654 -0.14423,-0.20192 -0.23077,-0.23077h-0.23077c0.17308,-0.23077 0.375,-0.66346 0.23077,-0.92308c-0.05769,-0.11538 -0.17307,-0.17307 -0.23077,-0.23077l0.92308,-0.69231c0.14423,-0.11538 0.20192,-0.28846 0.23077,-0.46154c0.02884,-0.08654 0.02884,-0.14423 0,-0.23077l-0.23077,-1.61538c-0.02884,-0.14423 0.11538,-0.34615 0,-0.46154c-0.11538,-0.11538 -0.34615,-0.14423 -0.46154,-0.23077c0.14423,-0.05769 0.375,-0.31731 0.46154,-0.46154c0.0577,-0.05769 0.20192,-0.14423 0.23077,-0.23077l0.23077,-1.15385l0.23077,-0.23077c0.08654,-0.08654 -0.02884,-0.11538 0,-0.23077l0.46154,-1.61538c0.0577,-0.08654 0.20192,-0.375 0.23077,-0.46154c0.02884,-0.08654 0,-0.14423 0,-0.23077v-0.69231c0.20192,-0.20192 0.34615,-0.66346 0.23077,-0.92308l-1.38462,-3.69231c1.67308,-0.92308 3.72115,-1.93269 5.30769,-2.76923c0.20192,-0.11538 0.20192,-0.23077 0.23077,-0.46154l0.23077,-1.15385c0.25961,-1.70192 0.43269,-3.75 0.69231,-5.30769c0.02884,-0.08654 0.02884,-0.14423 0,-0.23077l-0.92308,-4.38462l0.46154,-0.46154l0.69231,-0.23077c0.08654,-0.02884 0.14423,-0.17307 0.23077,-0.23077l0.23077,-0.23077l2.76923,-5.07692c0.0577,-0.08654 0.20192,-0.375 0.23077,-0.46154c0,-0.08654 0.02884,-0.17307 0,-0.23077l-0.92308,-3.92308c-0.05769,-0.20192 -0.25961,-0.375 -0.46154,-0.46154c-2.07692,-1.06731 -4.67307,-2.36538 -6.92308,-3.46154c-0.02884,-0.02884 -0.20192,-0.20192 -0.23077,-0.23077l-5.76923,-0.69231l-1.84615,-0.69231l-2.30769,-1.61538c-0.02884,-0.02884 -0.17307,-0.20192 -0.23077,-0.23077l-0.46154,-0.23077c0.11538,-0.20192 0.11538,-0.49038 0,-0.69231c-0.05769,-0.11538 -0.17307,-0.375 -0.23077,-0.46154c-0.14423,-0.17307 -0.25961,-0.28846 -0.46154,-0.23077h-0.23077l-1.61538,-1.38462l-2.07692,-3c-0.02884,-0.11538 -0.14423,-0.14423 -0.23077,-0.23077l-0.23077,-0.23077c-0.08654,-0.08654 -0.11538,-0.20192 -0.23077,-0.23077l-3.46154,-1.61538l-1.15385,-0.92308c-0.14423,-0.11538 -0.25961,-0.02884 -0.46154,0l-2.30769,0.23077l-2.30769,-2.53846l0.23077,-0.23077c0.25961,-0.11538 0.43269,-0.20192 0.46154,-0.46154c0.0577,-0.54808 0.02884,-1.03846 0,-1.38462l0.69231,-0.69231c0.14423,-0.14423 0.23077,-0.25961 0.23077,-0.46154v-0.46154c0,-0.40384 -0.31731,-0.66346 -0.69231,-0.69231c-0.95192,-0.05769 -1.75961,0 -2.53846,0c0,-0.05769 0,-0.20192 0,-0.23077c0,-0.14423 0.0577,-0.28846 -0.23077,-1.15385c0.28847,-0.17307 0.46154,-0.34615 0.46154,-0.69231c0,-0.14423 -0.02884,-0.17307 -0.46154,-1.38462c-0.02884,-0.20192 -0.05769,-0.60577 -0.23077,-1.15385c0.11538,-0.05769 0.14423,-0.08654 0.23077,-0.23077c0.23077,-0.40384 0.17308,-0.63461 -0.23077,-1.84615c-0.02884,-0.05769 0.02884,-0.17307 0,-0.23077c0.0577,-0.17307 0.0577,-0.28846 0,-0.46154c0.375,-0.14423 0.66346,-0.49038 0.69231,-0.92308c0,-0.14423 -0.05769,-0.11538 -0.46154,-1.38462c-0.17307,-0.31731 -0.46154,-0.60577 -0.69231,-0.69231c0.02884,-0.28846 -0.05769,-0.49038 -0.23077,-0.69231c-0.17307,-0.20192 -0.375,-0.43269 -0.69231,-0.46154h-0.23077c-0.08654,-0.34615 -0.46154,-0.57692 -0.92308,-0.69231c-0.63461,-0.17307 -1.32692,-0.31731 -2.07692,-0.46154c-0.375,-0.05769 -0.72115,-0.20192 -0.92308,-0.23077c-0.11538,-0.02884 -0.34615,-0.02884 -0.46154,0c-0.25961,0.0577 -0.54808,0.25961 -0.69231,0.46154c-0.28846,-0.20192 -0.43269,-0.49038 -0.69231,-0.69231l-0.69231,-0.46154c-0.14423,-0.14423 -0.49038,-0.28846 -0.69231,-0.23077c-0.31731,0.02884 -0.75,0.17308 -0.92308,0.46154l-2.07692,-1.15385l-0.92308,-0.46154c-0.11538,-0.08654 -0.20192,-0.17307 -0.46154,-0.23077c-0.11538,-0.02884 -0.34615,-0.02884 -0.46154,0c0.40385,-0.11538 0.66346,-0.40384 0.69231,-0.69231c0.0577,-0.31731 -0.05769,-0.49038 -0.69231,-2.07692c-0.17307,-0.43269 -0.51923,-0.57692 -0.92308,-0.46154c-0.17307,0.0577 -0.46154,0.11538 -0.69231,0.46154c-0.14423,0.25961 -0.31731,0.60577 -0.46154,0.92308l-0.23077,0.23077c-0.77885,-0.54808 -1.47116,-1.03846 -2.30769,-1.61538c-1.18269,-0.80769 -2.45192,-1.81731 -3.46154,-2.53846c-0.11538,-0.08654 -0.34615,0 -0.46154,0c-0.08654,0 -0.17307,-0.02884 -0.23077,0l-2.07692,0.46154c-0.05769,0.02884 -0.17307,-0.02884 -0.23077,0c-0.375,0.14423 -0.375,0.25961 -1.38462,2.53846c-0.11538,-0.11538 -0.34615,-0.17307 -0.46154,-0.23077c-0.11538,-0.02884 -0.11538,-0.25961 -0.23077,-0.23077l-3.46154,0.69231c-0.28846,0.02884 -0.375,0.17308 -0.46154,0.46154l-0.92308,2.76923l-0.92308,0.23077l-0.92308,-2.53846l0.92308,-5.07692l0.69231,-2.30769l0.69231,-1.15385c0.83654,-1.29808 1.73077,-2.76923 2.53846,-3.92308h1.15385l1.61538,1.61538c0.23077,0.23077 0.63462,0.17308 0.92308,0c0.66346,-0.375 0.98077,-1.18269 1.15385,-1.84615l2.07692,0.69231l-0.23077,6c-0.02884,0.28847 0,0.57692 0.23077,0.69231c0.63462,0.31731 1.06731,0.23077 1.38462,0.23077c0.17308,0 0.57692,-0.11538 0.69231,-0.23077h0.23077l0.23077,0.92308c0.08654,0.25961 0.28847,0.57692 0.92308,0.69231h0.92308c0.02884,0 0.20192,0 0.23077,0c0.43269,-0.05769 0.60577,-0.31731 0.69231,-0.69231c0.08654,-0.25961 0.11538,-0.23077 -0.23077,-2.07692c-0.11538,-0.46154 -0.46154,-0.92308 -0.92308,-0.92308h-0.69231l0.69231,-1.84615c0.17308,-1.24039 0.23077,-2.48077 0.46154,-3.69231l1.84615,-3h0.23077c0.11538,0 0.11538,0.0577 0.23077,0l2.07692,-1.38462c1.24039,-0.86538 2.59616,-1.78846 3.69231,-2.53846c0.08654,-0.05769 0.17308,-0.14423 0.23077,-0.23077c0.20192,-0.28846 0.20192,-0.51923 0.23077,-0.69231c0.17308,-0.83654 0.49038,-1.5 0.69231,-2.30769c0.0577,0.02884 0.17308,-0.05769 0.23077,0c0.28847,0.23077 0.66346,0.25961 0.92308,0l3,-3.23077c0.0577,-0.05769 0.20192,0.0577 0.23077,0l0.46154,-0.69231l3.23077,-0.46154c0.17308,-0.02884 0.57692,-0.08654 0.69231,-0.23077l0.92308,-0.92308c0.17308,-0.20192 0.08654,-0.66346 0,-0.92308l0.69231,-0.92308h0.69231c0.08654,0 0.17308,-0.20192 0.23077,-0.23077c0.02884,0 0.20192,0.02884 0.23077,0l2.30769,-1.15385v0.69231c-0.05769,0.20192 -0.14423,0.28847 0,0.46154l0.23077,0.23077c0.20192,0.23077 0.66346,0.34615 0.92308,0.23077c1.18269,-0.46154 2.56731,-0.86538 3.92308,-1.38462l1.38462,-0.69231c0.11538,-0.02884 0.375,-0.14423 0.46154,-0.23077l0.23077,-0.23077h0.92308c0.34615,-0.02884 0.40385,-0.20192 1.38462,-0.92308c0.08654,-0.08654 0.20192,-0.14423 0.23077,-0.23077c0.20192,-0.43269 0.0577,-0.83654 -0.23077,-1.15385l0.23077,-0.92308c0.02884,-0.20192 -0.08654,-0.51923 -0.23077,-0.69231c-0.17307,-0.20192 -0.51923,-0.43269 -0.92308,-0.46154c-0.43269,0.02884 -0.375,0.02884 -2.53846,2.30769l-0.46154,-0.46154c0.08654,-0.28846 0.17308,-0.63461 0.23077,-0.92308c0.17308,0 0.34615,-0.11538 0.46154,-0.23077l0.92308,-0.92308c0.17308,-0.14423 0.25961,-0.69231 0.23077,-0.92308c-0.02884,-0.17307 -0.11538,-0.34615 -0.23077,-0.46154h3.46154c-0.14423,0.08654 -0.43269,0.28847 -0.46154,0.69231c-0.02884,0.23077 -0.11538,0.28847 0,0.46154l-0.23077,0.69231c-0.11538,0.20192 -0.11538,0.72115 0,0.92308c0.20192,0.43269 0.17308,0.31731 2.30769,0.69231l0.23077,0.46154c0.08654,0.11538 0.375,0.43269 0.92308,0.46154h0.69231c0.20192,-0.02884 0.25961,-0.08654 0.46154,-0.23077c0.14423,0.11538 0.43269,0.17308 0.69231,0.23077h0.69231c0.31731,-0.05769 0.40385,-0.14423 1.84615,-1.15385c0.08654,-0.08654 0.17308,-0.17307 0.23077,-0.46154c0.02884,-0.17307 0.20192,-0.43269 0.23077,-0.69231c0,-0.40384 -0.14423,-0.51923 -0.46154,-0.69231v-0.23077c0.08654,-0.20192 0.28847,-0.51923 0.23077,-0.69231c-0.11538,-0.25961 -0.34615,-0.43269 -0.92308,-0.69231l1.15385,-1.15385c0.28847,-0.25961 0.375,-0.54808 0.23077,-0.92308c-0.08654,-0.20192 -0.23077,-0.375 -0.46154,-0.46154l0.92308,-1.15385c0.11538,-0.17307 0.0577,-0.49038 0,-0.69231c-0.08654,-0.23077 -0.20192,-0.40384 -0.46154,-0.46154l-1.61538,-0.23077c0.0577,-0.05769 0.20192,-0.17307 0.23077,-0.23077c0.20192,-0.57692 0.34615,-1.21153 0.46154,-1.61538c0.0577,-0.31731 -0.20192,-0.75 -0.46154,-0.92308l-0.23077,-0.23077l0.23077,-0.69231c0.34615,-2.19231 0.66346,-3.14423 0.69231,-3.23077c0.0577,-0.31731 -0.20192,-0.75 -0.46154,-0.92308c0.28847,-0.11538 0.28847,-0.25961 0.92308,-1.38462c0.0577,0.02884 0.17308,-0.02884 0.23077,0c0.0577,0 0.17308,0.23077 0.23077,0.23077h0.46154c0.43269,-0.02884 0.49038,-0.17307 2.30769,-2.07692c0.14423,0.08654 0.34615,0.23077 0.46154,0.23077c0.375,0 0.49038,-0.02884 3.46154,-1.61538c0.0577,-0.02884 0.20192,-0.20192 0.23077,-0.23077c0.14423,-0.11538 0.20192,-0.28846 0.23077,-0.46154c0.0577,-0.375 0.02884,-0.31731 -1.61538,-2.30769l0.92308,-0.92308c0.25961,-0.49038 0.20192,-0.72115 -1.38462,-3c-0.05769,-0.08654 -0.17307,0.0577 -0.23077,0c-0.05769,-0.05769 -0.17307,-0.20192 -0.23077,-0.23077c0.20192,-0.14423 0.40385,-0.34615 0.92308,-0.92308c0.02884,-0.02884 -0.02884,-0.20192 0,-0.23077c0.11538,0.0577 0.34615,0.02884 0.46154,0c0.72115,-0.14423 1.44231,-0.49038 2.07692,-0.92308c0.17308,-0.11538 0.31731,-0.375 0.46154,-0.46154h0.23077c0.0577,0 0.17308,0.02884 0.23077,0l1.15385,-0.23077c0.11538,-0.05769 0.34615,-0.08654 0.46154,-0.23077c0,0.11538 0.17308,0.11538 0.23077,0.23077c-0.05769,0.17308 -0.17307,0.28847 -0.23077,0.46154c-0.02884,0.08654 0,0.375 0,0.46154c0,0.08654 -0.02884,0.17308 0,0.23077l0.23077,0.46154c0.0577,0.17308 0.31731,0.375 0.46154,0.46154c0.11538,0.0577 0.31731,0 0.46154,0c0.69231,0.02884 1.32693,0.02884 1.84615,0l0.69231,0.23077v0.46154l-0.46154,1.38462c-0.05769,0.11538 -0.02884,0.57692 0,0.69231c0.02884,0.14423 0.11538,0.11538 0.23077,0.23077c-0.08654,0.17308 -0.08654,0.49038 0,0.69231c0.0577,0.14423 0.14423,0.31731 0.23077,0.46154v0.23077c0.0577,0.08654 0.17308,0.17308 0.23077,0.23077h-1.15385c-0.375,0.0577 -0.23077,0.02884 -1.84615,1.38462c-0.08654,0.08654 -0.17307,0.34615 -0.23077,0.46154c-0.02884,0.0577 -0.23077,-0.05769 -0.23077,0l-0.23077,1.61538c-0.02884,0.11538 -0.02884,0.11538 0,0.23077c0.0577,0.14423 0.375,0.34615 0.46154,0.46154c0,0.02884 -0.23077,0.20192 -0.23077,0.23077h-0.23077c-0.05769,0.02884 -0.17307,0.20192 -0.23077,0.23077c-0.08654,0.08654 -0.375,0.17308 -0.46154,0.46154c-0.02884,0.14423 -0.02884,0.31731 0,0.46154l0.92308,3.23077c0.02884,0.14423 0.11538,0.11538 0.23077,0.23077c0.14423,0.11538 0.34615,0.17308 0.46154,0.23077c0.08654,0.02884 0.14423,0.23077 0.23077,0.23077h0.69231l0.46154,0.69231c0.0577,0.08654 0.14423,0.17308 0.23077,0.23077c0.23077,0.17308 0.57692,0.31731 0.92308,0.23077l1.61538,-0.23077c0.08654,-0.02884 0.14423,-0.17307 0.23077,-0.23077l1.15385,-0.92308c1.03846,-1.06731 2.04808,-2.45192 3,-3.46154l2.30769,-0.69231c0.0577,0 0.20192,-0.20192 0.23077,-0.23077l0.46154,-0.23077l0.23077,0.23077c0.0577,0.02884 0.17308,0 0.23077,0c0.375,0 0.60577,-0.23077 1.84615,-1.15385l2.30769,-1.15385l1.15385,0.23077c0.0577,0.02884 0.17308,0.02884 0.23077,0h0.23077c1.41346,-0.51923 3.43269,-1.29808 4.84615,-1.84615c0.28847,0 0.57692,-0.20192 0.69231,-0.46154l0.23077,-0.46154c0.17308,-0.34615 0.31731,-0.86538 0.46154,-1.15385c0.0577,-0.11538 0.25961,-0.08654 0.23077,-0.23077c-0.02884,-0.20192 -0.08654,-0.31731 -0.23077,-0.46154c0.17308,-0.11538 0.20192,-0.49038 0.23077,-0.69231l0.46154,-2.30769c0.02884,-0.11538 0.0577,-0.31731 0,-0.46154c0.08654,-0.17307 0.08654,-0.25961 0,-0.46154c-0.23077,-0.49038 -0.46154,-1.18269 -0.69231,-1.61538c0.14423,-0.05769 0.14423,-0.08654 0.23077,-0.23077l0.46154,0.23077c0.23077,0.08654 0.49038,-0.05769 0.69231,-0.23077l0.46154,-0.46154c0.14423,-0.14423 0.23077,-0.25961 0.23077,-0.46154v-0.23077c0,-0.14423 0.08654,-0.34615 0,-0.46154c-0.43269,-0.60577 -1.21153,-0.77885 -1.84615,-0.92308c-0.20192,-0.05769 -0.40384,0.08654 -0.69231,0c-0.02884,0 -0.20192,0 -0.23077,0c-0.25961,0 -0.43269,-0.08654 -0.69231,0c-0.02884,-0.14423 -0.11538,-0.11538 -0.23077,-0.23077c-0.14423,-0.14423 -0.31731,-0.49038 -0.46154,-0.69231c-0.14423,-0.28846 -0.31731,-0.63461 -0.69231,-0.92308c-0.63461,-0.51923 -1.35577,-0.57692 -2.07692,-0.69231c-1.24039,-0.14423 -2.71153,-0.11538 -3.92308,0c-0.46154,0.02884 -0.95192,0.02884 -1.38462,0c-0.49038,-0.02884 -0.98077,-0.05769 -1.38462,0c-0.25961,0.02884 -0.49038,0.14423 -0.69231,0.23077c-0.17307,-0.08654 -0.63461,-0.05769 -0.92308,0c-0.83654,0.20192 -1.52884,0.77885 -2.30769,1.38462c-0.17307,0.14423 -0.51923,0.31731 -0.69231,0.46154c-0.11538,-0.23077 -0.43269,-0.46154 -0.69231,-0.46154c-0.69231,-0.02884 -0.72115,0 -0.92308,-0.23077c-0.05769,-0.08654 0.02884,-0.34615 0,-0.46154c-0.11538,-0.375 -0.49038,-0.98077 -1.38462,-1.15385c-0.02884,0 -0.17307,0 -0.23077,0c-0.23077,0 -0.51923,0.17308 -0.69231,0.23077c0.02884,0 0,-0.20192 0,-0.23077c0,-0.34615 0,-1.06731 -1.15385,-1.38462c-0.14423,-0.02884 -0.28846,0 -0.46154,0c-0.17307,0 -0.95192,-0.05769 -1.38462,0.23077c-0.40384,0.25961 -0.46154,0.57692 -0.46154,0.69231c-0.11538,0.08654 -0.05769,0.17308 -0.23077,0.23077c-0.14423,0.0577 -0.54808,0.11538 -0.69231,0.23077c-0.25961,0.17308 -0.49038,0.49038 -0.69231,0.69231c-0.20192,0.23077 -0.375,0.51923 -0.69231,0.46154c-0.20192,-0.08654 -0.28846,-0.08654 -0.46154,0c-0.57692,0.25961 -0.86538,0.57692 -0.92308,0.92308c-0.25961,0.25961 -0.60577,0.75 -0.69231,1.15385c-0.11538,0.08654 -0.46154,0.08654 -0.69231,0.23077v-0.92308c-0.08654,-0.375 -0.60577,-0.72115 -0.92308,-0.69231c-0.31731,0.02884 -0.43269,0.34615 -0.69231,0.69231l-1.38462,0.69231c-0.05769,0.02884 -0.17307,0.17308 -0.23077,0.23077l-1.15385,1.38462c-0.17307,0.20192 -0.34615,0.43269 -0.23077,0.69231v0.23077c-0.14423,-0.20192 -0.20192,-0.28846 -0.92308,-0.46154v-0.23077l0.69231,-0.92308c0.11538,-0.20192 0.11538,-0.46154 0,-0.69231c-0.11538,-0.25961 -0.40384,-0.43269 -0.69231,-0.46154c-0.31731,0.02884 -0.43269,-0.14423 -1.61538,0.69231c-0.05769,0.02884 -0.20192,0.20192 -0.23077,0.23077l-0.46154,1.15385c-0.08654,-0.05769 -0.14423,-0.20192 -0.23077,-0.23077c0.08654,-0.14423 0,-0.31731 0,-0.46154c-0.02884,-0.375 -0.20192,-0.54808 -0.69231,-0.92308c-0.14423,-0.08654 -0.28846,-0.05769 -0.46154,0c-0.14423,0.02884 -0.34615,-0.02884 -0.92308,0.23077c-0.43269,-0.20192 -0.98077,0.08654 -1.15385,0.23077c-0.14423,0.14423 -0.34615,0.31731 -0.46154,0.46154c-0.14423,-0.28846 -0.375,-0.49038 -0.69231,-0.46154l-2.53846,0.23077c-0.02884,0 -0.20192,-0.02884 -0.23077,0l-1.61538,0.69231c-0.40384,0.17308 -0.49038,0.25961 -0.92308,0.92308c-0.08654,0 -0.14423,0 -0.23077,0h-1.38462c-0.05769,0 -0.17307,-0.02884 -0.23077,0c-0.02884,0 -0.20192,0.23077 -0.23077,0.23077l-2.76923,1.15385c-0.05769,0.02884 -0.17307,-0.02884 -0.23077,0l-1.61538,1.15385c-0.25961,0.17308 -0.375,0.46154 -0.46154,0.69231c-0.08654,0.28847 0,0.51923 0.23077,0.69231c-0.08654,0.08654 -0.17307,0.11538 -0.23077,0.23077l-0.23077,-0.46154c-0.05769,-0.20192 -0.25961,-0.375 -0.46154,-0.46154c-0.02884,-0.08654 0.0577,-0.14423 0,-0.23077c-0.17307,-0.23077 -0.63461,-0.34615 -0.92308,-0.23077h-0.46154c12.34615,-7.26923 26.59616,-11.53846 42,-11.53846zM124.15385,19.84615l-0.92308,0.23077c-0.08654,0.02884 -0.14423,-0.05769 -0.23077,0l-0.46154,0.23077c-0.08654,-0.02884 -0.34615,-0.02884 -0.46154,0c-0.20192,0.02884 -0.34615,0.14423 -0.46154,0.23077h-1.15385c-0.28846,0 -0.57692,-0.02884 -0.69231,0.23077c-0.05769,0.11538 0,0.34615 0,0.46154c0,0.49038 0.02884,0.66346 1.15385,1.38462c0.02884,0.02884 0.20192,-0.02884 0.23077,0l0.92308,0.46154c0.17308,0.08654 0.51923,0.02884 0.69231,0l0.46154,0.69231c0.23077,0.28847 0.20192,0.46154 2.30769,1.15385c0.08654,0 0.17308,0.02884 0.23077,0c0.23077,-0.02884 0.375,-0.25961 0.46154,-0.46154c0.11538,-0.20192 0.31731,-0.49038 0.23077,-0.69231h0.69231c0.25961,-0.05769 0.60577,-0.20192 0.69231,-0.46154c0.11538,-0.28846 0,-0.72115 -0.23077,-0.92308c-0.08654,-0.05769 -0.14423,-0.08654 -0.92308,-0.46154c0.11538,-0.31731 -0.17307,-0.51923 -0.69231,-1.38462c-0.02884,-0.05769 0.0577,-0.17307 0,-0.23077c-0.23077,-0.20192 -0.40384,-0.17307 -1.38462,-0.46154c-0.05769,-0.02884 -0.17307,0 -0.23077,0c-0.05769,0 -0.17307,0 -0.23077,0zM71.07692,29.07692c0.28847,0.11538 0.77885,0.11538 1.15385,0.23077l-1.15385,0.92308c-0.02884,0.02884 0.02884,0.20192 0,0.23077l-0.69231,0.69231h-1.38462zM143.76923,29.07692c0.08654,0.02884 0.375,0 0.46154,0c0.08654,0 0.14423,0.02884 0.23077,0h0.23077c0.14423,0.08654 0.31731,0.14423 0.46154,0.23077c-0.05769,0.11538 -0.23077,0.11538 -0.23077,0.23077v0.46154zM68.30769,31.38462c-0.11538,0.08654 -0.25961,0.11538 -0.46154,0.23077c-0.02884,0.02884 -0.20192,0.20192 -0.23077,0.23077l-0.92308,0.92308c-0.08654,0.14423 -0.46154,0.51923 -0.23077,0.92308l-0.69231,-0.23077c-0.05769,-0.02884 -0.17307,0.02884 -0.23077,0l0.23077,-1.38462c0.02884,-0.08654 0.02884,-0.14423 0,-0.23077zM108,31.61538c-0.23077,0 -0.54808,0.14423 -2.07692,0.46154c-0.31731,0.11538 -0.375,0.17308 -0.46154,0.46154c-0.08654,0.25961 0.02884,0.75 0.23077,0.92308c0.25961,0.23077 0.60577,0.51923 0.92308,0.69231l-0.23077,0.46154c-0.05769,0.17308 -0.08654,0.51923 0,0.69231c0.20192,0.43269 0.08654,0.54808 3.69231,1.61538c0.0577,0.02884 0.17308,0 0.23077,0c0.25961,0 0.25961,0.08654 4.15385,-1.61538c0.43269,-0.28846 0.51923,-0.89423 0.46154,-1.15385c-0.05769,-0.20192 -0.14423,-0.40384 -0.23077,-0.69231c-0.05769,-0.11538 -0.14423,-0.14423 -0.23077,-0.23077c-0.02884,-0.02884 0.02884,-0.20192 0,-0.23077l-1.61538,-1.15385c-0.14423,-0.11538 -0.54808,-0.20192 -0.92308,-0.23077l-2.76923,0.46154l-0.69231,-0.23077c-0.11538,-0.05769 -0.34615,-0.23077 -0.46154,-0.23077zM59.53846,33.69231h1.38462l-0.23077,0.23077c-0.05769,0.375 0.34615,0.60577 0.69231,0.69231c0.46154,0.14423 0.66346,0.23077 0.92308,0.23077c0.08654,0 0.375,-0.20192 0.46154,-0.23077h0.69231c-0.51923,0.49038 -0.95192,1.03846 -1.38462,1.61538c-0.28846,0.375 -0.66346,0.86539 -0.92308,1.15385l-1.61538,0.46154c-0.14423,0.0577 -0.14423,0.08654 -0.23077,0.23077l-1.84615,2.76923l-3.46154,1.15385c-0.17307,0.0577 -0.375,0.28847 -0.46154,0.46154c-0.05769,0.11538 0.0577,0.11538 0,0.23077h-0.23077l-0.92308,-1.61538l-0.46154,-1.84615c-0.05769,-0.20192 -0.25961,-0.375 -0.46154,-0.46154c0.14423,-0.11538 0.20192,-0.25961 0.23077,-0.46154l0.23077,-0.46154l2.30769,-1.61538c0.80769,-0.31731 1.61538,-0.77885 2.53846,-1.15385l2.07692,-0.69231c0.08654,-0.02884 0.14423,-0.17307 0.23077,-0.23077c0.0577,-0.05769 0.17308,-0.17307 0.23077,-0.23077c0.14423,-0.11538 0.20192,-0.05769 0.23077,-0.23077zM69.23077,33.92308l0.23077,0.23077l-0.23077,0.23077c-0.46154,0.75 -0.11538,0.89423 2.30769,2.53846l-2.53846,1.15385l0.46154,-0.69231c0.25961,-0.25961 0.25961,-0.63461 0,-0.92308l-1.61538,-1.84615c-0.05769,-0.02884 -0.17307,-0.20192 -0.23077,-0.23077l-0.69231,-0.23077c0.43269,0.20192 0.69231,0.02884 2.30769,-0.23077zM140.53846,39.46154l1.15385,0.46154c0.14423,0.0577 0.31731,0.28847 0.46154,0.23077c0.14423,0.46154 0.25961,0.60577 0.46154,0.92308c0.02884,0.08654 0.17308,0.17308 0.23077,0.23077c0.08654,0.0577 0.14423,0.17308 0.23077,0.23077c-0.05769,0.14423 -0.05769,0.31731 0,0.46154l0.46154,1.38462c-0.54808,-0.14423 -1.26923,0.08654 -1.84615,0.23077c-0.14423,0.0577 -0.31731,0.20192 -0.46154,0.23077c-0.05769,0 -0.20192,-0.02884 -0.23077,0l-1.61538,0.69231v-0.23077c0.31731,-0.11538 0.49038,-0.34615 0.46154,-0.69231v-1.61538l0.23077,-0.69231l0.23077,-1.61538c0.02884,-0.08654 0.23077,-0.17307 0.23077,-0.23077zM157.84615,56.53846c0.0577,0.08654 0.14423,0.14423 0.23077,0.23077c1.52884,1.38462 1.47116,1.38462 1.84615,1.38462c0.14423,0 0.11538,0.08654 0.23077,0c0.14423,-0.05769 0.375,-0.11538 0.46154,-0.23077c0.11538,-0.17307 0.375,-0.31731 0.46154,-0.46154l2.53846,1.61538l0.92308,0.69231l-0.92308,0.23077c-1.03846,-0.72115 -1.09615,-0.69231 -1.38462,-0.69231c-0.08654,0 -0.375,-0.02884 -0.46154,0c-0.49038,0.17308 -1.06731,0.49038 -1.61538,0.69231c-0.46154,0.17308 -0.95192,0.31731 -1.38462,0.46154h-0.46154l-0.92308,-0.92308c-0.02884,-0.02884 0.02884,-0.17307 0,-0.23077c0.0577,-0.11538 0.23077,-0.25961 0.23077,-0.46154l-0.23077,-0.46154c0.11538,-0.11538 0.20192,-0.31731 0.23077,-0.46154c0.0577,-0.14423 0,-0.31731 0,-0.46154zM138.69231,59.76923c-0.02884,0.02884 0.02884,0.20192 0,0.23077c-0.08654,0.11538 0.02884,0.08654 0,0.23077c-0.02884,0.0577 -0.08654,0.23077 0,0.69231c0.08654,0.25961 0.17308,0.66346 0.23077,0.92308c0.0577,0.14423 0.14423,0.375 0.23077,0.46154c-0.02884,0.14423 -0.02884,0.23077 0,0.46154v0.46154c0.11538,0.46154 0.34615,0.89423 0.46154,1.38462c0.14423,0.60577 0.49038,0.86539 0.69231,0.92308c0.11538,0.02884 0.34615,0.02884 0.46154,0c0.02884,0 0.20192,-0.20192 0.23077,-0.23077l0.92308,-0.23077c0.375,-0.11538 0.69231,-0.51923 0.69231,-0.92308c0,-0.14423 0.0577,-0.23077 -0.46154,-1.84615c-0.11538,-0.28846 -0.375,-0.57692 -0.69231,-0.69231c0.0577,-0.17307 0.17308,-0.20192 0.23077,-0.46154l1.15385,1.15385c0.0577,0.0577 0.40385,0.20192 0.46154,0.23077l2.53846,1.38462l0.46154,0.23077l0.23077,0.69231l-1.84615,-0.46154c-0.14423,-0.02884 -0.54808,0.17308 -0.69231,0.23077c-0.28846,0.14423 -0.49038,0.375 -0.46154,0.69231c0.02884,0.23077 0.17308,0.60577 0.23077,0.92308c0.02884,0.11538 -0.08654,0.14423 0,0.23077c0.51923,0.66346 1.35577,1.15385 2.07692,1.61538c0.08654,0.0577 0.17308,0.17308 0.23077,0.23077c-0.46154,0.08654 -0.69231,0.40385 -0.69231,0.92308c-0.08654,-0.34615 -0.17307,-0.63461 -0.23077,-0.92308c-0.02884,-0.17307 -0.11538,-0.34615 -0.23077,-0.46154l-0.69231,-0.46154l-1.15385,-0.69231c-0.17307,-0.08654 -0.28846,-0.23077 -0.46154,-0.23077c-0.08654,0 -0.375,-0.02884 -0.46154,0l-1.15385,0.46154l-6.69231,0.46154c-0.05769,0 -0.17307,-0.02884 -0.23077,0l-4.38462,1.61538h-1.61538c0.0577,-0.05769 -0.02884,-0.17307 0,-0.23077l1.61538,-0.23077c0.08654,0 0.17308,0.02884 0.23077,0h0.23077c0.08654,-0.02884 0.17308,-0.17307 0.23077,-0.23077l1.38462,-1.15385l0.23077,-0.23077c0.20192,-0.23077 0.46154,-0.49038 0.69231,-0.69231c0.20192,-0.20192 0.31731,-0.63461 0.23077,-0.92308l-0.69231,-1.61538l0.23077,-0.46154l0.69231,-0.23077h0.23077c0.08654,0 0.14423,0.02884 0.23077,0c0.02884,0 0.20192,-0.23077 0.23077,-0.23077l0.69231,-0.46154c0.23077,-0.11538 0.43269,-0.23077 0.46154,-0.46154l0.23077,-1.38462v-0.23077l2.07692,0.46154c0.14423,0 0.34615,-0.14423 0.46154,-0.23077zM149.76923,64.15385h0.23077c0.17308,0 0.34615,0.08654 0.46154,0l0.23077,0.23077c0.0577,0.08654 -0.05769,0.17308 0,0.23077c0.0577,0.0577 0.11538,0.14423 0.23077,0.23077c0.11538,0.08654 0.31731,0.20192 0.46154,0.23077l0.92308,1.15385c0.11538,0.14423 0.28847,0.20192 0.46154,0.23077c0.08654,0.02884 0.14423,-0.02884 0.23077,0c0,0.02884 -0.02884,0.20192 0,0.23077c0.17308,0.28847 0.49038,0.57692 0.69231,0.92308l0.23077,0.46154c0.0577,0.11538 0.11538,0.375 0.23077,0.46154h0.23077c0.11538,0.08654 0.31731,0.23077 0.46154,0.23077h0.69231c-0.02884,0.08654 0,0.11538 0,0.23077c0.0577,0.17308 0.02884,0.08654 0.46154,0.92308c0.25961,0.43269 0.20192,0.54808 3.23077,1.15385c0.86539,-0.08654 1.00962,-0.80769 0.92308,-2.07692l0.23077,0.23077c0.17308,0.17308 0.43269,0.28847 0.69231,0.23077l1.38462,-0.46154c0.11538,-0.02884 0.14423,0.0577 0.23077,0h0.23077c-0.11538,0.11538 -0.20192,0.34615 -0.23077,0.46154c-0.05769,0.34615 -0.05769,0.66346 0.23077,0.92308c0.08654,0.0577 0.28847,0.0577 1.38462,0.69231c0.0577,0.02884 -0.05769,0.20192 0,0.23077h0.23077c0.14423,0.02884 0.31731,-0.17307 0.46154,-0.23077c0.11538,-0.05769 0.14423,-0.14423 0.23077,-0.23077l0.46154,-0.46154c0.08654,0.28847 0.14423,0.63462 0.23077,0.92308l-0.23077,3l-1.84615,-0.69231c-0.31731,-0.08654 -0.51923,0.20192 -0.69231,0.46154l-0.69231,0.69231l-2.76923,-1.15385c-0.08654,-0.02884 -0.14423,-0.02884 -0.23077,0c-0.43269,0.02884 -0.80769,0 -1.15385,0l-0.23077,-0.23077c-0.11538,-0.17307 -0.25961,-0.43269 -0.46154,-0.46154c-0.95192,-0.14423 -1.58654,0 -2.30769,0c-0.08654,0 -0.14423,-0.02884 -0.23077,0c-0.05769,0.02884 -0.20192,-0.02884 -0.23077,0l-0.69231,0.46154c-0.17307,0.11538 -0.43269,0.25961 -0.46154,0.46154l-0.23077,1.38462l-3.23077,-1.84615c-0.02884,-0.02884 -0.20192,0.02884 -0.23077,0l-3.46154,-0.92308l-0.92308,-0.46154c0.08654,-0.14423 0,-0.28846 0,-0.46154c-0.05769,-0.72115 -0.14423,-1.24039 -0.23077,-1.84615c0.08654,0.25961 0.31731,0.40385 0.46154,0.69231c0.08654,0.14423 0.14423,0.46154 0.23077,0.69231c0.25961,0.46154 0.57692,0.43269 0.69231,0.46154c0.08654,0.02884 0.14423,0.02884 0.23077,0c0.46154,-0.05769 0.63462,-0.23077 1.38462,-1.38462c0.0577,-0.08654 -0.02884,-0.14423 0,-0.23077c0.02884,-0.11538 0.02884,-0.11538 0,-0.23077c-0.02884,-0.17307 0.08654,-0.34615 0,-0.46154c0.34615,-0.14423 0.43269,-0.51923 0.46154,-0.92308v-1.15385c0.20192,-0.05769 0.375,-0.25961 0.46154,-0.46154l0.69231,-1.38462c0.11538,-0.20192 0.11538,-0.49038 0,-0.69231zM157.15385,66.23077c0.11538,0.14423 0.40385,0.20192 0.46154,0.23077l0.92308,1.61538c-0.40384,-0.02884 -0.98077,-0.20192 -1.38462,-0.23077v-0.23077c0.14423,-0.14423 0.23077,-0.25961 0.23077,-0.46154c0,-0.40384 -0.17307,-0.66346 -0.23077,-0.92308zM23.07692,88.84615c0.0577,0.0577 0.14423,0.17308 0.23077,0.23077v0.23077c-0.08654,0.28847 -0.14423,0.57692 0,1.38462c0.11538,0.34615 0.17308,0.28847 0.46154,0.46154c0.17308,0.11538 0.49038,0.0577 0.69231,0c0.0577,-0.02884 0.17308,0.02884 0.23077,0c-0.08654,0.83654 0.28847,1.64423 0.92308,2.07692c0.28847,0.20192 0.57692,0.46154 0.92308,0.46154c1.00962,0 1.70192,-0.92308 1.84615,-2.07692c0.0577,-0.40384 0.11538,-0.80769 0,-1.15385l0.46154,0.46154c0,0.14423 -0.20192,0.08654 -0.23077,0.23077v0.69231c0.0577,0.40385 0.34615,0.75 0.69231,0.92308h-0.46154c-0.11538,-0.02884 -0.14423,0 -0.23077,0c-0.34615,0.08654 -0.49038,0.08654 -1.15385,0.92308c-0.17307,0.23077 -0.28846,0.63462 -0.23077,0.92308c0.0577,0.25961 0.28847,0.34615 0.46154,0.46154c0.375,0.31731 0.72115,0.69231 1.15385,0.92308l0.46154,0.23077c0.08654,0.0577 0.375,-0.02884 0.46154,0v0.23077c0.08654,0.02884 0.14423,0 0.23077,0c0.0577,-0.02884 0.17308,-0.20192 0.23077,-0.23077l1.38462,-0.46154c0.25961,-0.17307 0.43269,-0.51923 0.46154,-0.92308v-0.46154c0.34615,0.23077 1.125,0.34615 3.23077,0.69231c0.0577,0 0.17308,0 0.23077,0c0.02884,0 0.20192,0 0.23077,0c0.0577,0 0.17308,0 0.23077,0h3.46154c0.17308,0.25961 0.54808,0.43269 0.92308,0.46154h2.30769c0.25961,-0.02884 0.51923,-0.08654 0.69231,-0.23077c0.14423,0.11538 0.28847,0.28847 0.46154,0.46154c0.20192,0.14423 0.46154,0.23077 0.69231,0.23077c0.0577,0 0.17308,0.02884 0.23077,0l0.46154,-0.23077v0.23077c0.0577,0.375 0.31731,0.77885 0.69231,0.92308c-0.08654,0.14423 -0.20192,0.25961 -0.23077,0.46154c0,0.46154 0.23077,0.92308 0.23077,1.38462v0.46154c0.08654,0.54808 0.46154,0.83654 0.69231,0.92308v0.46154c-0.08654,0.14423 -0.23077,0.25961 -0.23077,0.46154c0,0.40385 -0.02884,0.95192 0,1.38462c0.02884,0.28847 0.23077,0.51923 0.46154,0.69231c0,0.23077 -0.02884,0.46154 0,0.69231c-0.11538,0.17308 -0.20192,0.43269 -0.23077,0.69231c0.02884,0.31731 -0.02884,0.60577 0,0.92308v0.23077c0.0577,0.40385 0.40385,0.83654 0.92308,0.92308v0.46154l-1.38462,-1.15385c-0.05769,-0.05769 -0.17307,-0.20192 -0.23077,-0.23077l-2.53846,-0.46154c-0.11538,-0.02884 -0.34615,-0.02884 -0.46154,0h-0.23077l-0.46154,0.23077l-3,-0.69231l-1.61538,-2.07692c-0.05769,-0.08654 -0.14423,-0.20192 -0.23077,-0.23077h-0.23077c-0.25961,-0.14423 -0.69231,-0.23077 -0.92308,0l-0.46154,0.69231l-0.46154,-0.23077c-0.20192,-0.11538 -0.28846,-0.34615 -0.46154,-0.46154c-0.23077,-0.11538 -0.46154,-0.11538 -0.69231,0l-3.46154,1.84615c-0.05769,0.02884 -0.17307,0.17308 -0.23077,0.23077c-0.05769,0.0577 -0.20192,0.14423 -0.23077,0.23077l-0.92308,2.53846l-1.15385,-0.69231c-0.08654,-0.05769 -0.11538,-0.20192 -0.23077,-0.23077h-0.23077c-0.05769,0 -0.20192,0 -0.23077,0l-2.07692,0.46154l-0.69231,-1.38462l0.23077,-6.23077c0.02884,-0.14423 0,-0.31731 0,-0.46154c0,-0.14423 0.0577,-0.11538 0,-0.23077c-0.34615,-0.60577 -0.92308,-1.29808 -1.38462,-1.84615l-0.23077,-0.23077c-0.05769,-0.05769 -0.17307,-0.17307 -0.23077,-0.23077c-0.08654,-0.05769 -0.14423,-0.20192 -0.23077,-0.23077l-1.84615,-0.23077v-1.61538zM32.07692,92.53846c0,0.0577 0,0.20192 0,0.23077c-0.17307,0.23077 -0.23077,0.43269 -0.23077,0.69231c-0.11538,-0.14423 -0.31731,-0.20192 -0.46154,-0.23077c-0.51923,-0.14423 -1.00962,-0.34615 -1.61538,-0.46154zM173.76923,94.38462c0.40385,0.89423 0.80769,1.73077 1.15385,2.53846v1.84615c-0.08654,-0.14423 -0.28846,-0.17307 -0.46154,-0.23077l-0.46154,-3v-0.23077zM13.15385,97.61538l0.46154,0.46154c0.23077,0.23077 0.63462,0.375 0.92308,0.23077l0.92308,-0.69231l0.69231,1.84615c0,0.02884 0,0.20192 0,0.23077c0.02884,0.08654 0.17308,0.17308 0.23077,0.23077l0.46154,0.69231c0.02884,0.0577 -0.05769,0.20192 0,0.23077l0.92308,0.92308c0.0577,0.02884 0.40385,0.20192 0.46154,0.23077l1.15385,0.69231l1.84615,5.53846c0.02884,0.02884 -0.02884,0.20192 0,0.23077l0.46154,0.46154c0.20192,0.23077 0.63462,0.375 0.92308,0.23077l0.23077,-0.23077l0.69231,0.92308c0.0577,0.17308 0.0577,0.375 0.23077,0.46154c0.14423,0.08654 0.34615,0.17308 0.46154,0.23077c0.08654,0.02884 0.17308,-0.02884 0.23077,0l0.92308,1.38462c0.17308,0.25961 0.60577,0.375 0.92308,0.23077l0.92308,-0.46154c0.14423,-0.05769 0.375,-0.31731 0.46154,-0.46154l0.23077,0.69231c0.28847,2.01923 0.75,3.98077 1.15385,6l-0.23077,1.38462l-0.46154,1.38462l-0.46154,3c-0.02884,0.08654 -0.02884,0.14423 0,0.23077c0,0.02884 0,0.20192 0,0.23077c0.17308,0.69231 0.25961,1.41346 0.46154,2.07692l0.23077,0.23077c0.02884,0.11538 -0.08654,0.14423 0,0.23077c0.0577,0.0577 0.28847,0.08654 0.46154,0.23077l-0.23077,0.23077c-0.08654,0.14423 -0.02884,0.28847 0,0.46154c0,0.0577 0.20192,0.17308 0.23077,0.23077l1.38462,3.23077c0.02884,0.0577 -0.05769,0.17308 0,0.23077l3,2.53846l1.38462,2.07692c0.02884,0.0577 0.20192,0.20192 0.23077,0.23077c0.0577,0.08654 0,0.23077 0,0.23077c2.19231,2.88462 5.42308,6.75 6,7.15385l4.15385,2.07692c0.375,0.23077 0.77885,0.40385 2.07692,1.15385l0.46154,0.46154c1.58654,2.42308 3.86539,5.91346 5.76923,8.53846c4.21154,5.33654 5.25,6.86539 10.61538,12.23077c0.02884,0.02884 0.20192,-0.02884 0.23077,0l1.38462,1.15385c0.20192,0.20192 0.49038,0.25961 0.69231,0.46154l0.23077,0.46154c0.0577,0.0577 0.17308,-0.02884 0.23077,0c0.28847,0.17308 0.60577,0.375 0.92308,0.46154c0.0577,0.25961 0.20192,0.31731 1.38462,1.15385c0.20192,0.14423 0.46154,0.23077 0.69231,0.23077l0.46154,0.69231c0.08654,0.11538 0.08654,0.17308 0.23077,0.23077l0.92308,0.46154l0.23077,0.23077c0.0577,0.08654 0.14423,0.17308 0.23077,0.23077c0.40385,0.25961 0.92308,0.31731 1.38462,0.46154l0.23077,0.23077c0.0577,0.23077 0.28847,0.34615 0.46154,0.46154c0.08654,0.08654 0.17308,0.20192 0.23077,0.23077c0.14423,0.08654 0.25961,0.17308 0.46154,0.23077l0.69231,0.46154c0.11538,0.0577 0.34615,0.23077 0.46154,0.23077h0.46154c0.02884,0.02884 0.20192,0.20192 0.23077,0.23077h0.46154c0.08654,0.17308 0.28847,0.375 0.46154,0.46154c-36.375,-8.27885 -63.63461,-40.41346 -64.38462,-79.15385zM178.38462,102.69231c-0.02884,0.28847 0.02884,0.63462 0,0.92308l-0.23077,0.23077c-0.375,0.25961 -0.77885,0.43269 -1.15385,0.69231l-0.23077,-0.23077v-0.46154c0.08654,-0.02884 0.17308,-0.20192 0.23077,-0.23077c0.0577,-0.02884 0.20192,0.02884 0.23077,0zM138.69231,119.07692c-1.06731,0.14423 -1.875,0.89423 -2.07692,1.84615c-0.17307,0.77885 0.0577,1.41346 0.69231,1.84615c0.34615,0.23077 0.72115,0.46154 1.15385,0.46154c1.06731,0 2.04808,-0.86538 2.30769,-1.84615c0.17308,-0.54808 0.11538,-1.15385 -0.23077,-1.61538c-0.34615,-0.49038 -0.89423,-0.69231 -1.61538,-0.69231c-0.02884,0 -0.20192,0 -0.23077,0zM175.38462,119.53846c-1.78846,6.08654 -4.09615,11.88462 -7.15385,17.30769c-0.11538,0.08654 -0.02884,0.11538 -0.69231,0.92308c0.11538,-0.46154 -0.25961,-0.80769 -0.46154,-0.92308c-0.05769,-0.02884 -0.17307,-0.20192 -0.23077,-0.23077c-0.23077,-0.05769 -0.46154,0 -0.69231,0h-0.23077l0.23077,-0.46154c0.11538,-0.23077 0.11538,-0.43269 0.23077,-0.69231l0.23077,-0.46154c0.0577,-0.08654 0.23077,-0.11538 0.23077,-0.23077v-0.46154l0.92308,-3l0.23077,-0.92308l0.92308,-1.61538l0.46154,-0.46154c0.0577,-0.05769 0.20192,-0.14423 0.23077,-0.23077c0.31731,-0.75 0.34615,-1.21153 0.46154,-1.61538l0.92308,-1.61538l0.69231,-0.69231c0.11538,-0.05769 0.14423,-0.11538 0.23077,-0.23077l2.76923,-4.15385zM164.76923,139.61538c0.17308,0.11538 0.28847,-0.02884 0.46154,0c0.0577,0.02884 0.17308,0 0.23077,0c0.11538,-0.02884 0.375,0.08654 0.46154,0c-0.34615,0.43269 -0.92308,0.80769 -1.38462,1.38462l-1.15385,0.69231z"></path></g></g></g></svg>
               </div>
               <div class="who_see_list_box">
                   <div class="who_see_item hvr-underline-from-center" id="1" data-ic="everyone" data-nm="<?php echo $page_Lang['show_post_everyone'][$dataUserPageLanguage];?>"><div class="w-see"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="24" height="24" viewBox="0 0 192 192" style=" fill:#000000;"><g fill="none" fill-rule="nonzero" stroke="none" stroke-width="1" stroke-linecap="butt" stroke-linejoin="miter" stroke-miterlimit="10" stroke-dasharray="" stroke-dashoffset="0" font-family="none" font-weight="none" font-size="none" text-anchor="none" style="mix-blend-mode: normal"><path d="M0,192v-192h192v192z" fill="none"></path><g fill="#8a99a4"><g id="surface1"><path d="M96,1.15385c-52.32692,0 -94.84615,42.51923 -94.84615,94.84615c0,52.32693 42.51923,94.84615 94.84615,94.84615c52.32693,0 94.84615,-42.51923 94.84615,-94.84615c0,-52.32692 -42.51923,-94.84615 -94.84615,-94.84615zM96,13.15385c15.63462,0 30.23077,4.26923 42.69231,11.76923c0.08654,0.0577 0.14423,0.17308 0.23077,0.23077c0.14423,0.14423 0.31731,0.31731 0.46154,0.46154c0.14423,0.17308 0.20192,0.11538 0.46154,0.23077c0.08654,0.40385 0.25961,0.69231 0.46154,0.92308c0.08654,0.08654 0.11538,0.28847 0.23077,0.46154c0.17308,0.23077 0.40385,0.49038 3,1.84615c-0.31731,-0.14423 -0.69231,-0.02884 -0.92308,0.23077c-0.11538,0.14423 -0.23077,0.28847 -0.23077,0.46154c-0.28846,-0.14423 -0.63461,-0.31731 -0.92308,-0.46154c-0.375,-0.14423 -0.54808,-0.28846 -0.92308,-0.46154c-0.05769,-0.02884 -0.17307,0.02884 -0.23077,0l-1.61538,-0.23077c-0.11538,-0.02884 -0.34615,-0.05769 -0.46154,0c-0.05769,0.02884 -0.17307,-0.02884 -0.23077,0l-0.92308,-0.23077l-0.92308,-0.46154c-0.05769,-0.02884 -0.40384,-0.23077 -0.46154,-0.23077l-1.38462,-0.23077c-0.05769,0 -0.17307,0 -0.23077,0h-0.92308c-0.14423,0 -0.34615,0.17308 -0.46154,0.23077c-0.14423,0.08654 -0.17307,0.08654 -0.23077,0.23077l-0.23077,0.46154l-0.69231,0.23077c-0.17307,0.02884 -0.34615,0.08654 -0.46154,0.23077c-0.05769,0.08654 -0.20192,0.34615 -0.23077,0.46154l-0.23077,0.23077c-0.11538,0.11538 -0.20192,0.31731 -0.23077,0.46154l-0.23077,0.46154c-0.08654,0.08654 -0.20192,0.34615 -0.23077,0.46154c-0.02884,0.08654 -0.02884,0.14423 0,0.23077v0.46154l-0.23077,2.76923c0,0.0577 -0.02884,0.14423 0,0.23077c-0.05769,0.02884 -0.17307,0.17308 -0.23077,0.23077l-1.38462,2.07692c-0.20192,0.23077 -0.40384,0.43269 -0.23077,0.69231l2.30769,3.46154l0.23077,0.69231c0.0577,0.11538 0.14423,0.14423 0.23077,0.23077c0.51923,0.43269 1.24039,0.57692 1.84615,0.69231c0.08654,0 0.14423,-0.02884 0.23077,0v1.15385c-0.02884,0.20192 0.08654,0.54808 0.23077,0.69231l0.46154,0.69231c0.02884,0.08654 0.17308,0.14423 0.23077,0.23077l-1.15385,0.46154c-0.08654,0.02884 -0.14423,-0.05769 -0.23077,0c-0.02884,0.02884 -0.20192,0.20192 -0.23077,0.23077l-0.46154,0.69231c-0.14423,0 -0.31731,0.11538 -0.46154,0.23077l-0.46154,0.46154c-0.05769,0.0577 -0.20192,0.17308 -0.23077,0.23077c-0.02884,0.02884 0.02884,0.20192 0,0.23077l-0.23077,0.46154v-0.69231c0,-0.02884 0,-0.20192 0,-0.23077c-0.05769,-0.34615 -0.02884,-0.34615 -4.15385,-4.15385v-0.92308c0,-0.05769 0,-0.40384 0,-0.46154l-0.23077,-0.23077c-0.02884,-0.05769 0.02884,-0.17307 0,-0.23077c-0.17307,-0.28846 -0.25961,-0.28846 -1.61538,-0.92308v-0.46154c-0.20192,-0.375 -0.66346,-0.43269 -1.15385,-0.46154h-0.92308c-0.72115,0.0577 -0.77885,0.17308 -1.38462,3.23077c0,0.11538 -0.05769,0.375 0,0.46154c0.02884,0.0577 -0.02884,0.17308 0,0.23077c-0.05769,0 -0.40384,0.20192 -0.46154,0.23077c-0.17307,0.02884 -0.31731,0.08654 -0.46154,0.23077c-0.05769,0.02884 -0.17307,-0.02884 -0.23077,0c-0.08654,0.0577 -0.02884,0.14423 -0.23077,0.23077c-0.05769,0.02884 -0.20192,-0.02884 -0.23077,0c-0.43269,0 -0.77885,0.28847 -1.38462,0.92308c-0.11538,0.17308 -0.05769,0.49038 0,0.69231l0.23077,0.92308c0.08654,0.23077 0.17308,0.25961 0.46154,0.46154c-0.05769,0.0577 -0.20192,0.20192 -0.23077,0.23077c-0.05769,0.08654 0.02884,0.14423 0,0.23077l-0.23077,1.15385c-0.02884,0.25961 0.0577,0.72115 0.23077,0.92308c0.14423,0.17308 0.43269,0.31731 0.92308,0.23077l2.07692,-0.46154c0.0577,-0.02884 0.20192,0.02884 0.23077,0l1.61538,-0.69231c0.02884,-0.02884 0.20192,0.02884 0.23077,0c0.02884,0.02884 -0.02884,0.20192 0,0.23077h-0.23077c-0.05769,0.0577 -0.17307,0.14423 -0.23077,0.23077c-0.02884,0.02884 0.02884,0.17308 0,0.23077l-0.46154,0.92308c-0.05769,0.25961 0.0577,0.69231 0.23077,0.92308c0.17308,0.23077 0.51923,0.43269 0.92308,0.46154h0.69231l-0.23077,0.69231c-0.02884,0.08654 0,0.14423 0,0.23077c0,0.0577 0,0.17308 0,0.23077c0.0577,0.28847 -0.05769,0.63462 0,0.92308c0.0577,0.11538 0.375,0.60577 0.46154,0.69231c0.14423,0.14423 0.25961,0.23077 0.46154,0.23077c0.46154,0.02884 0.77885,0 1.15385,0l1.61538,1.15385l-0.23077,0.46154c0,0.0577 0,0.40385 0,0.46154l0.23077,0.92308c-0.66346,-0.11538 -0.77885,-0.34615 -3.46154,-0.69231c-0.23077,-0.05769 -0.46154,-0.05769 -1.38462,-0.23077c-0.11538,-0.02884 -0.14423,-0.02884 -0.23077,0l-0.46154,0.23077c-0.20192,0.0577 -0.375,0.23077 -0.46154,0.46154c-0.05769,0.08654 0.0577,0.11538 0,0.23077h-0.46154c-0.17307,0.02884 -0.34615,0.31731 -0.46154,0.46154c-0.02884,0.02884 -0.17307,-0.05769 -0.23077,0c-0.14423,0.14423 -0.25961,0.49038 -0.23077,0.69231c0.14423,0.92308 0.31731,2.27885 0.46154,3.23077l-0.46154,2.53846c0,0.0577 0,0.17308 0,0.23077c0.02884,0.08654 -0.02884,0.23077 0,0.46154c0.02884,0.17308 0.08654,0.34615 0.23077,0.46154l0.46154,0.46154l0.69231,1.84615c0.17308,0.46154 0.66346,0.77885 1.15385,0.69231l1.38462,-0.23077l0.69231,0.46154l-4.61538,3.92308c-0.08654,0.0577 -0.20192,0.375 -0.23077,0.46154l-0.69231,3.23077l-3.23077,2.07692l-1.38462,0.69231c-0.17307,0.08654 -0.375,0.28847 -0.46154,0.46154c-0.60577,1.35577 -1.67307,2.94231 -2.53846,4.38462c-0.375,0.63462 -0.54808,1.18269 -0.92308,1.84615l-1.84615,3.69231c-0.05769,0.11538 -0.02884,0.34615 0,0.46154c0.02884,0.43269 0,0.46154 0,0.69231c0,0.11538 -0.05769,0.375 0,0.46154c0,0.02884 0.20192,0.20192 0.23077,0.23077l0.46154,0.69231l0.46154,3.46154l-2.30769,4.38462c-0.14423,0.25961 0,0.69231 0.23077,0.92308l0.92308,0.92308c0,0.43269 0.02884,0.92308 0,1.38462c-0.02884,0.08654 0,0.14423 0,0.23077v0.23077c0,0.14423 -0.08654,0.34615 0,0.46154l0.69231,1.15385l1.15385,1.15385l2.30769,3.23077c0.0577,0.08654 0.17308,0.17308 0.23077,0.23077l1.38462,1.15385l0.92308,1.38462c0.02884,0.02884 0.20192,-0.02884 0.23077,0l0.46154,0.23077c0.02884,0.02884 -0.02884,0.20192 0,0.23077l0.23077,0.23077c0.0577,0.0577 0.14423,-0.02884 0.23077,0l3.23077,1.84615l1.15385,0.92308c0.11538,0.08654 0.08654,0.20192 0.23077,0.23077c0.02884,0 0.17308,0 0.23077,0c0.51923,0 1.21154,-0.25961 1.61538,-0.46154l2.30769,-0.23077h3.69231c0.02884,0 0.20192,-0.23077 0.23077,-0.23077l3.46154,-0.23077c0.08654,0.02884 0.14423,0.02884 0.23077,0h0.46154c0.08654,-0.02884 0.17308,-0.17307 0.23077,-0.23077l1.38462,-0.69231h1.38462l0.92308,-0.23077l0.69231,2.07692c0.11538,0.31731 0.60577,0.51923 0.92308,0.46154h2.53846l0.92308,1.38462l0.23077,0.46154l-2.07692,4.15385c-0.08654,0.17308 -0.08654,0.28847 0,0.46154l1.84615,4.38462l0.23077,0.92308v0.92308c0,0.02884 0,0.23077 0,0.23077c0,0.11538 0.17308,0.14423 0.23077,0.23077c0.02884,0.11538 0.20192,0.34615 0.23077,0.46154c0.0577,0.11538 -0.02884,0.28847 0,0.46154l0.23077,0.46154l-0.46154,1.38462l-0.92308,5.07692l-1.61538,1.38462l-0.69231,1.84615l-0.46154,0.23077c-0.05769,0.02884 -0.40384,0.17308 -0.46154,0.23077c-0.11538,0.08654 -0.17307,0.11538 -0.23077,0.23077c-0.40384,0.98077 -0.80769,1.90385 -1.15385,2.76923c-0.02884,0.08654 0,0.375 0,0.46154c-0.02884,0.08654 -0.02884,0.14423 0,0.23077l0.46154,1.84615c-0.80769,3 -1.73077,6.23077 -2.53846,8.53846c-0.02884,0.02884 -0.23077,0.20192 -0.23077,0.23077v0.69231l-0.69231,1.61538c-0.28846,0.60577 -0.40384,0.83654 -0.92308,1.84615l-0.69231,0.69231c-0.43269,0.49038 -0.86538,1.24039 -1.15385,1.84615l-0.23077,0.46154c-0.11538,0.17308 -0.08654,0.25961 0,0.46154c0.08654,0.20192 0.25961,0.375 0.46154,0.46154c0.46154,0.17308 0.83654,0.23077 1.15385,0.23077c0.08654,0 0.14423,0.02884 0.23077,0c0.25961,-0.11538 0.63462,-0.28846 0.92308,-0.46154v-0.23077c1.21154,-0.23077 2.79808,-0.40384 4.15385,-0.69231l2.53846,-1.15385c0.0577,-0.02884 0.20192,-0.20192 0.23077,-0.23077l3.69231,-2.53846c0.02884,-0.02884 0.20192,0.02884 0.23077,0v-0.23077c0.46154,-0.31731 1.5577,-0.92308 1.84615,-1.15385l1.84615,-2.07692l0.92308,-0.92308l0.46154,-0.23077h0.46154c0.08654,0 0.14423,0.02884 0.23077,0c0.40385,-0.17307 0.66346,-0.66346 0.92308,-0.92308l2.30769,-2.30769c0.0577,-0.05769 0.20192,-0.17307 0.23077,-0.23077l1.38462,-2.53846l0.23077,-0.23077h0.23077c0.11538,0 0.14423,-0.17307 0.23077,-0.23077c0.40385,-0.17307 0.69231,-0.40384 0.92308,-0.69231l0.46154,-0.46154c1.03846,-0.72115 2.27885,-1.75961 3,-2.30769h0.23077c-0.11538,0.14423 -0.11538,0.28847 -0.23077,0.46154c-0.05769,0.0577 -0.20192,0.40385 -0.23077,0.46154l-0.92308,1.61538l-1.84615,1.61538c-0.14423,0.17308 -0.14423,0.17308 -2.53846,3.69231c-0.17307,0.31731 -0.20192,0.72115 -0.23077,1.15385c-0.02884,0.28847 0,0.54808 0.23077,0.69231c-15.02884,15.40385 -36.02884,24.92308 -59.30769,24.92308c-3.92308,0 -7.75961,-0.40384 -11.53846,-0.92308c0.08654,-0.17307 0.0577,-0.51923 0,-0.69231c0.11538,0.02884 0.34615,0.02884 0.46154,0c0.11538,-0.02884 0.14423,-0.17307 0.23077,-0.23077c0.14423,-0.11538 0.43269,-0.25961 0.46154,-0.46154c0.02884,-0.20192 -0.08654,-0.51923 -0.23077,-0.69231l-0.69231,-0.69231c-0.14423,-0.14423 -0.11538,-0.31731 -0.92308,-0.69231c-0.08654,-0.02884 -0.14423,0 -0.23077,0c-0.11538,-0.02884 -0.34615,0.17308 -0.46154,0.23077c-0.14423,0.0577 -0.34615,-0.05769 -0.46154,0c-0.28846,0.17308 -0.34615,0.60577 -0.23077,0.92308c0.02884,0.14423 0.11538,0.23077 0.23077,0.46154l-1.15385,-0.23077c-0.05769,-0.02884 -0.14423,-0.20192 -0.23077,-0.23077c-0.05769,-0.02884 -0.17307,0 -0.23077,0l-0.23077,-0.23077c-0.05769,-0.05769 -0.17307,-0.20192 -0.23077,-0.23077l-0.92308,-0.46154l-0.92308,-1.38462c-0.02884,-0.02884 -0.20192,-0.23077 -0.23077,-0.23077c-0.17307,-0.17307 -0.28846,-0.25961 -0.46154,-0.46154c-0.08654,-0.08654 -0.11538,-0.17307 -0.23077,-0.23077l-0.92308,-0.23077c0,-0.17307 -0.11538,-0.31731 -0.23077,-0.46154c-0.72115,-0.83654 -1.41346,-1.73077 -2.07692,-2.53846c-0.05769,-0.08654 -0.14423,-0.20192 -0.23077,-0.23077h-0.23077c0.17308,-0.23077 0.375,-0.66346 0.23077,-0.92308c-0.05769,-0.11538 -0.17307,-0.17307 -0.23077,-0.23077l0.92308,-0.69231c0.14423,-0.11538 0.20192,-0.28846 0.23077,-0.46154c0.02884,-0.08654 0.02884,-0.14423 0,-0.23077l-0.23077,-1.61538c-0.02884,-0.14423 0.11538,-0.34615 0,-0.46154c-0.11538,-0.11538 -0.34615,-0.14423 -0.46154,-0.23077c0.14423,-0.05769 0.375,-0.31731 0.46154,-0.46154c0.0577,-0.05769 0.20192,-0.14423 0.23077,-0.23077l0.23077,-1.15385l0.23077,-0.23077c0.08654,-0.08654 -0.02884,-0.11538 0,-0.23077l0.46154,-1.61538c0.0577,-0.08654 0.20192,-0.375 0.23077,-0.46154c0.02884,-0.08654 0,-0.14423 0,-0.23077v-0.69231c0.20192,-0.20192 0.34615,-0.66346 0.23077,-0.92308l-1.38462,-3.69231c1.67308,-0.92308 3.72115,-1.93269 5.30769,-2.76923c0.20192,-0.11538 0.20192,-0.23077 0.23077,-0.46154l0.23077,-1.15385c0.25961,-1.70192 0.43269,-3.75 0.69231,-5.30769c0.02884,-0.08654 0.02884,-0.14423 0,-0.23077l-0.92308,-4.38462l0.46154,-0.46154l0.69231,-0.23077c0.08654,-0.02884 0.14423,-0.17307 0.23077,-0.23077l0.23077,-0.23077l2.76923,-5.07692c0.0577,-0.08654 0.20192,-0.375 0.23077,-0.46154c0,-0.08654 0.02884,-0.17307 0,-0.23077l-0.92308,-3.92308c-0.05769,-0.20192 -0.25961,-0.375 -0.46154,-0.46154c-2.07692,-1.06731 -4.67307,-2.36538 -6.92308,-3.46154c-0.02884,-0.02884 -0.20192,-0.20192 -0.23077,-0.23077l-5.76923,-0.69231l-1.84615,-0.69231l-2.30769,-1.61538c-0.02884,-0.02884 -0.17307,-0.20192 -0.23077,-0.23077l-0.46154,-0.23077c0.11538,-0.20192 0.11538,-0.49038 0,-0.69231c-0.05769,-0.11538 -0.17307,-0.375 -0.23077,-0.46154c-0.14423,-0.17307 -0.25961,-0.28846 -0.46154,-0.23077h-0.23077l-1.61538,-1.38462l-2.07692,-3c-0.02884,-0.11538 -0.14423,-0.14423 -0.23077,-0.23077l-0.23077,-0.23077c-0.08654,-0.08654 -0.11538,-0.20192 -0.23077,-0.23077l-3.46154,-1.61538l-1.15385,-0.92308c-0.14423,-0.11538 -0.25961,-0.02884 -0.46154,0l-2.30769,0.23077l-2.30769,-2.53846l0.23077,-0.23077c0.25961,-0.11538 0.43269,-0.20192 0.46154,-0.46154c0.0577,-0.54808 0.02884,-1.03846 0,-1.38462l0.69231,-0.69231c0.14423,-0.14423 0.23077,-0.25961 0.23077,-0.46154v-0.46154c0,-0.40384 -0.31731,-0.66346 -0.69231,-0.69231c-0.95192,-0.05769 -1.75961,0 -2.53846,0c0,-0.05769 0,-0.20192 0,-0.23077c0,-0.14423 0.0577,-0.28846 -0.23077,-1.15385c0.28847,-0.17307 0.46154,-0.34615 0.46154,-0.69231c0,-0.14423 -0.02884,-0.17307 -0.46154,-1.38462c-0.02884,-0.20192 -0.05769,-0.60577 -0.23077,-1.15385c0.11538,-0.05769 0.14423,-0.08654 0.23077,-0.23077c0.23077,-0.40384 0.17308,-0.63461 -0.23077,-1.84615c-0.02884,-0.05769 0.02884,-0.17307 0,-0.23077c0.0577,-0.17307 0.0577,-0.28846 0,-0.46154c0.375,-0.14423 0.66346,-0.49038 0.69231,-0.92308c0,-0.14423 -0.05769,-0.11538 -0.46154,-1.38462c-0.17307,-0.31731 -0.46154,-0.60577 -0.69231,-0.69231c0.02884,-0.28846 -0.05769,-0.49038 -0.23077,-0.69231c-0.17307,-0.20192 -0.375,-0.43269 -0.69231,-0.46154h-0.23077c-0.08654,-0.34615 -0.46154,-0.57692 -0.92308,-0.69231c-0.63461,-0.17307 -1.32692,-0.31731 -2.07692,-0.46154c-0.375,-0.05769 -0.72115,-0.20192 -0.92308,-0.23077c-0.11538,-0.02884 -0.34615,-0.02884 -0.46154,0c-0.25961,0.0577 -0.54808,0.25961 -0.69231,0.46154c-0.28846,-0.20192 -0.43269,-0.49038 -0.69231,-0.69231l-0.69231,-0.46154c-0.14423,-0.14423 -0.49038,-0.28846 -0.69231,-0.23077c-0.31731,0.02884 -0.75,0.17308 -0.92308,0.46154l-2.07692,-1.15385l-0.92308,-0.46154c-0.11538,-0.08654 -0.20192,-0.17307 -0.46154,-0.23077c-0.11538,-0.02884 -0.34615,-0.02884 -0.46154,0c0.40385,-0.11538 0.66346,-0.40384 0.69231,-0.69231c0.0577,-0.31731 -0.05769,-0.49038 -0.69231,-2.07692c-0.17307,-0.43269 -0.51923,-0.57692 -0.92308,-0.46154c-0.17307,0.0577 -0.46154,0.11538 -0.69231,0.46154c-0.14423,0.25961 -0.31731,0.60577 -0.46154,0.92308l-0.23077,0.23077c-0.77885,-0.54808 -1.47116,-1.03846 -2.30769,-1.61538c-1.18269,-0.80769 -2.45192,-1.81731 -3.46154,-2.53846c-0.11538,-0.08654 -0.34615,0 -0.46154,0c-0.08654,0 -0.17307,-0.02884 -0.23077,0l-2.07692,0.46154c-0.05769,0.02884 -0.17307,-0.02884 -0.23077,0c-0.375,0.14423 -0.375,0.25961 -1.38462,2.53846c-0.11538,-0.11538 -0.34615,-0.17307 -0.46154,-0.23077c-0.11538,-0.02884 -0.11538,-0.25961 -0.23077,-0.23077l-3.46154,0.69231c-0.28846,0.02884 -0.375,0.17308 -0.46154,0.46154l-0.92308,2.76923l-0.92308,0.23077l-0.92308,-2.53846l0.92308,-5.07692l0.69231,-2.30769l0.69231,-1.15385c0.83654,-1.29808 1.73077,-2.76923 2.53846,-3.92308h1.15385l1.61538,1.61538c0.23077,0.23077 0.63462,0.17308 0.92308,0c0.66346,-0.375 0.98077,-1.18269 1.15385,-1.84615l2.07692,0.69231l-0.23077,6c-0.02884,0.28847 0,0.57692 0.23077,0.69231c0.63462,0.31731 1.06731,0.23077 1.38462,0.23077c0.17308,0 0.57692,-0.11538 0.69231,-0.23077h0.23077l0.23077,0.92308c0.08654,0.25961 0.28847,0.57692 0.92308,0.69231h0.92308c0.02884,0 0.20192,0 0.23077,0c0.43269,-0.05769 0.60577,-0.31731 0.69231,-0.69231c0.08654,-0.25961 0.11538,-0.23077 -0.23077,-2.07692c-0.11538,-0.46154 -0.46154,-0.92308 -0.92308,-0.92308h-0.69231l0.69231,-1.84615c0.17308,-1.24039 0.23077,-2.48077 0.46154,-3.69231l1.84615,-3h0.23077c0.11538,0 0.11538,0.0577 0.23077,0l2.07692,-1.38462c1.24039,-0.86538 2.59616,-1.78846 3.69231,-2.53846c0.08654,-0.05769 0.17308,-0.14423 0.23077,-0.23077c0.20192,-0.28846 0.20192,-0.51923 0.23077,-0.69231c0.17308,-0.83654 0.49038,-1.5 0.69231,-2.30769c0.0577,0.02884 0.17308,-0.05769 0.23077,0c0.28847,0.23077 0.66346,0.25961 0.92308,0l3,-3.23077c0.0577,-0.05769 0.20192,0.0577 0.23077,0l0.46154,-0.69231l3.23077,-0.46154c0.17308,-0.02884 0.57692,-0.08654 0.69231,-0.23077l0.92308,-0.92308c0.17308,-0.20192 0.08654,-0.66346 0,-0.92308l0.69231,-0.92308h0.69231c0.08654,0 0.17308,-0.20192 0.23077,-0.23077c0.02884,0 0.20192,0.02884 0.23077,0l2.30769,-1.15385v0.69231c-0.05769,0.20192 -0.14423,0.28847 0,0.46154l0.23077,0.23077c0.20192,0.23077 0.66346,0.34615 0.92308,0.23077c1.18269,-0.46154 2.56731,-0.86538 3.92308,-1.38462l1.38462,-0.69231c0.11538,-0.02884 0.375,-0.14423 0.46154,-0.23077l0.23077,-0.23077h0.92308c0.34615,-0.02884 0.40385,-0.20192 1.38462,-0.92308c0.08654,-0.08654 0.20192,-0.14423 0.23077,-0.23077c0.20192,-0.43269 0.0577,-0.83654 -0.23077,-1.15385l0.23077,-0.92308c0.02884,-0.20192 -0.08654,-0.51923 -0.23077,-0.69231c-0.17307,-0.20192 -0.51923,-0.43269 -0.92308,-0.46154c-0.43269,0.02884 -0.375,0.02884 -2.53846,2.30769l-0.46154,-0.46154c0.08654,-0.28846 0.17308,-0.63461 0.23077,-0.92308c0.17308,0 0.34615,-0.11538 0.46154,-0.23077l0.92308,-0.92308c0.17308,-0.14423 0.25961,-0.69231 0.23077,-0.92308c-0.02884,-0.17307 -0.11538,-0.34615 -0.23077,-0.46154h3.46154c-0.14423,0.08654 -0.43269,0.28847 -0.46154,0.69231c-0.02884,0.23077 -0.11538,0.28847 0,0.46154l-0.23077,0.69231c-0.11538,0.20192 -0.11538,0.72115 0,0.92308c0.20192,0.43269 0.17308,0.31731 2.30769,0.69231l0.23077,0.46154c0.08654,0.11538 0.375,0.43269 0.92308,0.46154h0.69231c0.20192,-0.02884 0.25961,-0.08654 0.46154,-0.23077c0.14423,0.11538 0.43269,0.17308 0.69231,0.23077h0.69231c0.31731,-0.05769 0.40385,-0.14423 1.84615,-1.15385c0.08654,-0.08654 0.17308,-0.17307 0.23077,-0.46154c0.02884,-0.17307 0.20192,-0.43269 0.23077,-0.69231c0,-0.40384 -0.14423,-0.51923 -0.46154,-0.69231v-0.23077c0.08654,-0.20192 0.28847,-0.51923 0.23077,-0.69231c-0.11538,-0.25961 -0.34615,-0.43269 -0.92308,-0.69231l1.15385,-1.15385c0.28847,-0.25961 0.375,-0.54808 0.23077,-0.92308c-0.08654,-0.20192 -0.23077,-0.375 -0.46154,-0.46154l0.92308,-1.15385c0.11538,-0.17307 0.0577,-0.49038 0,-0.69231c-0.08654,-0.23077 -0.20192,-0.40384 -0.46154,-0.46154l-1.61538,-0.23077c0.0577,-0.05769 0.20192,-0.17307 0.23077,-0.23077c0.20192,-0.57692 0.34615,-1.21153 0.46154,-1.61538c0.0577,-0.31731 -0.20192,-0.75 -0.46154,-0.92308l-0.23077,-0.23077l0.23077,-0.69231c0.34615,-2.19231 0.66346,-3.14423 0.69231,-3.23077c0.0577,-0.31731 -0.20192,-0.75 -0.46154,-0.92308c0.28847,-0.11538 0.28847,-0.25961 0.92308,-1.38462c0.0577,0.02884 0.17308,-0.02884 0.23077,0c0.0577,0 0.17308,0.23077 0.23077,0.23077h0.46154c0.43269,-0.02884 0.49038,-0.17307 2.30769,-2.07692c0.14423,0.08654 0.34615,0.23077 0.46154,0.23077c0.375,0 0.49038,-0.02884 3.46154,-1.61538c0.0577,-0.02884 0.20192,-0.20192 0.23077,-0.23077c0.14423,-0.11538 0.20192,-0.28846 0.23077,-0.46154c0.0577,-0.375 0.02884,-0.31731 -1.61538,-2.30769l0.92308,-0.92308c0.25961,-0.49038 0.20192,-0.72115 -1.38462,-3c-0.05769,-0.08654 -0.17307,0.0577 -0.23077,0c-0.05769,-0.05769 -0.17307,-0.20192 -0.23077,-0.23077c0.20192,-0.14423 0.40385,-0.34615 0.92308,-0.92308c0.02884,-0.02884 -0.02884,-0.20192 0,-0.23077c0.11538,0.0577 0.34615,0.02884 0.46154,0c0.72115,-0.14423 1.44231,-0.49038 2.07692,-0.92308c0.17308,-0.11538 0.31731,-0.375 0.46154,-0.46154h0.23077c0.0577,0 0.17308,0.02884 0.23077,0l1.15385,-0.23077c0.11538,-0.05769 0.34615,-0.08654 0.46154,-0.23077c0,0.11538 0.17308,0.11538 0.23077,0.23077c-0.05769,0.17308 -0.17307,0.28847 -0.23077,0.46154c-0.02884,0.08654 0,0.375 0,0.46154c0,0.08654 -0.02884,0.17308 0,0.23077l0.23077,0.46154c0.0577,0.17308 0.31731,0.375 0.46154,0.46154c0.11538,0.0577 0.31731,0 0.46154,0c0.69231,0.02884 1.32693,0.02884 1.84615,0l0.69231,0.23077v0.46154l-0.46154,1.38462c-0.05769,0.11538 -0.02884,0.57692 0,0.69231c0.02884,0.14423 0.11538,0.11538 0.23077,0.23077c-0.08654,0.17308 -0.08654,0.49038 0,0.69231c0.0577,0.14423 0.14423,0.31731 0.23077,0.46154v0.23077c0.0577,0.08654 0.17308,0.17308 0.23077,0.23077h-1.15385c-0.375,0.0577 -0.23077,0.02884 -1.84615,1.38462c-0.08654,0.08654 -0.17307,0.34615 -0.23077,0.46154c-0.02884,0.0577 -0.23077,-0.05769 -0.23077,0l-0.23077,1.61538c-0.02884,0.11538 -0.02884,0.11538 0,0.23077c0.0577,0.14423 0.375,0.34615 0.46154,0.46154c0,0.02884 -0.23077,0.20192 -0.23077,0.23077h-0.23077c-0.05769,0.02884 -0.17307,0.20192 -0.23077,0.23077c-0.08654,0.08654 -0.375,0.17308 -0.46154,0.46154c-0.02884,0.14423 -0.02884,0.31731 0,0.46154l0.92308,3.23077c0.02884,0.14423 0.11538,0.11538 0.23077,0.23077c0.14423,0.11538 0.34615,0.17308 0.46154,0.23077c0.08654,0.02884 0.14423,0.23077 0.23077,0.23077h0.69231l0.46154,0.69231c0.0577,0.08654 0.14423,0.17308 0.23077,0.23077c0.23077,0.17308 0.57692,0.31731 0.92308,0.23077l1.61538,-0.23077c0.08654,-0.02884 0.14423,-0.17307 0.23077,-0.23077l1.15385,-0.92308c1.03846,-1.06731 2.04808,-2.45192 3,-3.46154l2.30769,-0.69231c0.0577,0 0.20192,-0.20192 0.23077,-0.23077l0.46154,-0.23077l0.23077,0.23077c0.0577,0.02884 0.17308,0 0.23077,0c0.375,0 0.60577,-0.23077 1.84615,-1.15385l2.30769,-1.15385l1.15385,0.23077c0.0577,0.02884 0.17308,0.02884 0.23077,0h0.23077c1.41346,-0.51923 3.43269,-1.29808 4.84615,-1.84615c0.28847,0 0.57692,-0.20192 0.69231,-0.46154l0.23077,-0.46154c0.17308,-0.34615 0.31731,-0.86538 0.46154,-1.15385c0.0577,-0.11538 0.25961,-0.08654 0.23077,-0.23077c-0.02884,-0.20192 -0.08654,-0.31731 -0.23077,-0.46154c0.17308,-0.11538 0.20192,-0.49038 0.23077,-0.69231l0.46154,-2.30769c0.02884,-0.11538 0.0577,-0.31731 0,-0.46154c0.08654,-0.17307 0.08654,-0.25961 0,-0.46154c-0.23077,-0.49038 -0.46154,-1.18269 -0.69231,-1.61538c0.14423,-0.05769 0.14423,-0.08654 0.23077,-0.23077l0.46154,0.23077c0.23077,0.08654 0.49038,-0.05769 0.69231,-0.23077l0.46154,-0.46154c0.14423,-0.14423 0.23077,-0.25961 0.23077,-0.46154v-0.23077c0,-0.14423 0.08654,-0.34615 0,-0.46154c-0.43269,-0.60577 -1.21153,-0.77885 -1.84615,-0.92308c-0.20192,-0.05769 -0.40384,0.08654 -0.69231,0c-0.02884,0 -0.20192,0 -0.23077,0c-0.25961,0 -0.43269,-0.08654 -0.69231,0c-0.02884,-0.14423 -0.11538,-0.11538 -0.23077,-0.23077c-0.14423,-0.14423 -0.31731,-0.49038 -0.46154,-0.69231c-0.14423,-0.28846 -0.31731,-0.63461 -0.69231,-0.92308c-0.63461,-0.51923 -1.35577,-0.57692 -2.07692,-0.69231c-1.24039,-0.14423 -2.71153,-0.11538 -3.92308,0c-0.46154,0.02884 -0.95192,0.02884 -1.38462,0c-0.49038,-0.02884 -0.98077,-0.05769 -1.38462,0c-0.25961,0.02884 -0.49038,0.14423 -0.69231,0.23077c-0.17307,-0.08654 -0.63461,-0.05769 -0.92308,0c-0.83654,0.20192 -1.52884,0.77885 -2.30769,1.38462c-0.17307,0.14423 -0.51923,0.31731 -0.69231,0.46154c-0.11538,-0.23077 -0.43269,-0.46154 -0.69231,-0.46154c-0.69231,-0.02884 -0.72115,0 -0.92308,-0.23077c-0.05769,-0.08654 0.02884,-0.34615 0,-0.46154c-0.11538,-0.375 -0.49038,-0.98077 -1.38462,-1.15385c-0.02884,0 -0.17307,0 -0.23077,0c-0.23077,0 -0.51923,0.17308 -0.69231,0.23077c0.02884,0 0,-0.20192 0,-0.23077c0,-0.34615 0,-1.06731 -1.15385,-1.38462c-0.14423,-0.02884 -0.28846,0 -0.46154,0c-0.17307,0 -0.95192,-0.05769 -1.38462,0.23077c-0.40384,0.25961 -0.46154,0.57692 -0.46154,0.69231c-0.11538,0.08654 -0.05769,0.17308 -0.23077,0.23077c-0.14423,0.0577 -0.54808,0.11538 -0.69231,0.23077c-0.25961,0.17308 -0.49038,0.49038 -0.69231,0.69231c-0.20192,0.23077 -0.375,0.51923 -0.69231,0.46154c-0.20192,-0.08654 -0.28846,-0.08654 -0.46154,0c-0.57692,0.25961 -0.86538,0.57692 -0.92308,0.92308c-0.25961,0.25961 -0.60577,0.75 -0.69231,1.15385c-0.11538,0.08654 -0.46154,0.08654 -0.69231,0.23077v-0.92308c-0.08654,-0.375 -0.60577,-0.72115 -0.92308,-0.69231c-0.31731,0.02884 -0.43269,0.34615 -0.69231,0.69231l-1.38462,0.69231c-0.05769,0.02884 -0.17307,0.17308 -0.23077,0.23077l-1.15385,1.38462c-0.17307,0.20192 -0.34615,0.43269 -0.23077,0.69231v0.23077c-0.14423,-0.20192 -0.20192,-0.28846 -0.92308,-0.46154v-0.23077l0.69231,-0.92308c0.11538,-0.20192 0.11538,-0.46154 0,-0.69231c-0.11538,-0.25961 -0.40384,-0.43269 -0.69231,-0.46154c-0.31731,0.02884 -0.43269,-0.14423 -1.61538,0.69231c-0.05769,0.02884 -0.20192,0.20192 -0.23077,0.23077l-0.46154,1.15385c-0.08654,-0.05769 -0.14423,-0.20192 -0.23077,-0.23077c0.08654,-0.14423 0,-0.31731 0,-0.46154c-0.02884,-0.375 -0.20192,-0.54808 -0.69231,-0.92308c-0.14423,-0.08654 -0.28846,-0.05769 -0.46154,0c-0.14423,0.02884 -0.34615,-0.02884 -0.92308,0.23077c-0.43269,-0.20192 -0.98077,0.08654 -1.15385,0.23077c-0.14423,0.14423 -0.34615,0.31731 -0.46154,0.46154c-0.14423,-0.28846 -0.375,-0.49038 -0.69231,-0.46154l-2.53846,0.23077c-0.02884,0 -0.20192,-0.02884 -0.23077,0l-1.61538,0.69231c-0.40384,0.17308 -0.49038,0.25961 -0.92308,0.92308c-0.08654,0 -0.14423,0 -0.23077,0h-1.38462c-0.05769,0 -0.17307,-0.02884 -0.23077,0c-0.02884,0 -0.20192,0.23077 -0.23077,0.23077l-2.76923,1.15385c-0.05769,0.02884 -0.17307,-0.02884 -0.23077,0l-1.61538,1.15385c-0.25961,0.17308 -0.375,0.46154 -0.46154,0.69231c-0.08654,0.28847 0,0.51923 0.23077,0.69231c-0.08654,0.08654 -0.17307,0.11538 -0.23077,0.23077l-0.23077,-0.46154c-0.05769,-0.20192 -0.25961,-0.375 -0.46154,-0.46154c-0.02884,-0.08654 0.0577,-0.14423 0,-0.23077c-0.17307,-0.23077 -0.63461,-0.34615 -0.92308,-0.23077h-0.46154c12.34615,-7.26923 26.59616,-11.53846 42,-11.53846zM124.15385,19.84615l-0.92308,0.23077c-0.08654,0.02884 -0.14423,-0.05769 -0.23077,0l-0.46154,0.23077c-0.08654,-0.02884 -0.34615,-0.02884 -0.46154,0c-0.20192,0.02884 -0.34615,0.14423 -0.46154,0.23077h-1.15385c-0.28846,0 -0.57692,-0.02884 -0.69231,0.23077c-0.05769,0.11538 0,0.34615 0,0.46154c0,0.49038 0.02884,0.66346 1.15385,1.38462c0.02884,0.02884 0.20192,-0.02884 0.23077,0l0.92308,0.46154c0.17308,0.08654 0.51923,0.02884 0.69231,0l0.46154,0.69231c0.23077,0.28847 0.20192,0.46154 2.30769,1.15385c0.08654,0 0.17308,0.02884 0.23077,0c0.23077,-0.02884 0.375,-0.25961 0.46154,-0.46154c0.11538,-0.20192 0.31731,-0.49038 0.23077,-0.69231h0.69231c0.25961,-0.05769 0.60577,-0.20192 0.69231,-0.46154c0.11538,-0.28846 0,-0.72115 -0.23077,-0.92308c-0.08654,-0.05769 -0.14423,-0.08654 -0.92308,-0.46154c0.11538,-0.31731 -0.17307,-0.51923 -0.69231,-1.38462c-0.02884,-0.05769 0.0577,-0.17307 0,-0.23077c-0.23077,-0.20192 -0.40384,-0.17307 -1.38462,-0.46154c-0.05769,-0.02884 -0.17307,0 -0.23077,0c-0.05769,0 -0.17307,0 -0.23077,0zM71.07692,29.07692c0.28847,0.11538 0.77885,0.11538 1.15385,0.23077l-1.15385,0.92308c-0.02884,0.02884 0.02884,0.20192 0,0.23077l-0.69231,0.69231h-1.38462zM143.76923,29.07692c0.08654,0.02884 0.375,0 0.46154,0c0.08654,0 0.14423,0.02884 0.23077,0h0.23077c0.14423,0.08654 0.31731,0.14423 0.46154,0.23077c-0.05769,0.11538 -0.23077,0.11538 -0.23077,0.23077v0.46154zM68.30769,31.38462c-0.11538,0.08654 -0.25961,0.11538 -0.46154,0.23077c-0.02884,0.02884 -0.20192,0.20192 -0.23077,0.23077l-0.92308,0.92308c-0.08654,0.14423 -0.46154,0.51923 -0.23077,0.92308l-0.69231,-0.23077c-0.05769,-0.02884 -0.17307,0.02884 -0.23077,0l0.23077,-1.38462c0.02884,-0.08654 0.02884,-0.14423 0,-0.23077zM108,31.61538c-0.23077,0 -0.54808,0.14423 -2.07692,0.46154c-0.31731,0.11538 -0.375,0.17308 -0.46154,0.46154c-0.08654,0.25961 0.02884,0.75 0.23077,0.92308c0.25961,0.23077 0.60577,0.51923 0.92308,0.69231l-0.23077,0.46154c-0.05769,0.17308 -0.08654,0.51923 0,0.69231c0.20192,0.43269 0.08654,0.54808 3.69231,1.61538c0.0577,0.02884 0.17308,0 0.23077,0c0.25961,0 0.25961,0.08654 4.15385,-1.61538c0.43269,-0.28846 0.51923,-0.89423 0.46154,-1.15385c-0.05769,-0.20192 -0.14423,-0.40384 -0.23077,-0.69231c-0.05769,-0.11538 -0.14423,-0.14423 -0.23077,-0.23077c-0.02884,-0.02884 0.02884,-0.20192 0,-0.23077l-1.61538,-1.15385c-0.14423,-0.11538 -0.54808,-0.20192 -0.92308,-0.23077l-2.76923,0.46154l-0.69231,-0.23077c-0.11538,-0.05769 -0.34615,-0.23077 -0.46154,-0.23077zM59.53846,33.69231h1.38462l-0.23077,0.23077c-0.05769,0.375 0.34615,0.60577 0.69231,0.69231c0.46154,0.14423 0.66346,0.23077 0.92308,0.23077c0.08654,0 0.375,-0.20192 0.46154,-0.23077h0.69231c-0.51923,0.49038 -0.95192,1.03846 -1.38462,1.61538c-0.28846,0.375 -0.66346,0.86539 -0.92308,1.15385l-1.61538,0.46154c-0.14423,0.0577 -0.14423,0.08654 -0.23077,0.23077l-1.84615,2.76923l-3.46154,1.15385c-0.17307,0.0577 -0.375,0.28847 -0.46154,0.46154c-0.05769,0.11538 0.0577,0.11538 0,0.23077h-0.23077l-0.92308,-1.61538l-0.46154,-1.84615c-0.05769,-0.20192 -0.25961,-0.375 -0.46154,-0.46154c0.14423,-0.11538 0.20192,-0.25961 0.23077,-0.46154l0.23077,-0.46154l2.30769,-1.61538c0.80769,-0.31731 1.61538,-0.77885 2.53846,-1.15385l2.07692,-0.69231c0.08654,-0.02884 0.14423,-0.17307 0.23077,-0.23077c0.0577,-0.05769 0.17308,-0.17307 0.23077,-0.23077c0.14423,-0.11538 0.20192,-0.05769 0.23077,-0.23077zM69.23077,33.92308l0.23077,0.23077l-0.23077,0.23077c-0.46154,0.75 -0.11538,0.89423 2.30769,2.53846l-2.53846,1.15385l0.46154,-0.69231c0.25961,-0.25961 0.25961,-0.63461 0,-0.92308l-1.61538,-1.84615c-0.05769,-0.02884 -0.17307,-0.20192 -0.23077,-0.23077l-0.69231,-0.23077c0.43269,0.20192 0.69231,0.02884 2.30769,-0.23077zM140.53846,39.46154l1.15385,0.46154c0.14423,0.0577 0.31731,0.28847 0.46154,0.23077c0.14423,0.46154 0.25961,0.60577 0.46154,0.92308c0.02884,0.08654 0.17308,0.17308 0.23077,0.23077c0.08654,0.0577 0.14423,0.17308 0.23077,0.23077c-0.05769,0.14423 -0.05769,0.31731 0,0.46154l0.46154,1.38462c-0.54808,-0.14423 -1.26923,0.08654 -1.84615,0.23077c-0.14423,0.0577 -0.31731,0.20192 -0.46154,0.23077c-0.05769,0 -0.20192,-0.02884 -0.23077,0l-1.61538,0.69231v-0.23077c0.31731,-0.11538 0.49038,-0.34615 0.46154,-0.69231v-1.61538l0.23077,-0.69231l0.23077,-1.61538c0.02884,-0.08654 0.23077,-0.17307 0.23077,-0.23077zM157.84615,56.53846c0.0577,0.08654 0.14423,0.14423 0.23077,0.23077c1.52884,1.38462 1.47116,1.38462 1.84615,1.38462c0.14423,0 0.11538,0.08654 0.23077,0c0.14423,-0.05769 0.375,-0.11538 0.46154,-0.23077c0.11538,-0.17307 0.375,-0.31731 0.46154,-0.46154l2.53846,1.61538l0.92308,0.69231l-0.92308,0.23077c-1.03846,-0.72115 -1.09615,-0.69231 -1.38462,-0.69231c-0.08654,0 -0.375,-0.02884 -0.46154,0c-0.49038,0.17308 -1.06731,0.49038 -1.61538,0.69231c-0.46154,0.17308 -0.95192,0.31731 -1.38462,0.46154h-0.46154l-0.92308,-0.92308c-0.02884,-0.02884 0.02884,-0.17307 0,-0.23077c0.0577,-0.11538 0.23077,-0.25961 0.23077,-0.46154l-0.23077,-0.46154c0.11538,-0.11538 0.20192,-0.31731 0.23077,-0.46154c0.0577,-0.14423 0,-0.31731 0,-0.46154zM138.69231,59.76923c-0.02884,0.02884 0.02884,0.20192 0,0.23077c-0.08654,0.11538 0.02884,0.08654 0,0.23077c-0.02884,0.0577 -0.08654,0.23077 0,0.69231c0.08654,0.25961 0.17308,0.66346 0.23077,0.92308c0.0577,0.14423 0.14423,0.375 0.23077,0.46154c-0.02884,0.14423 -0.02884,0.23077 0,0.46154v0.46154c0.11538,0.46154 0.34615,0.89423 0.46154,1.38462c0.14423,0.60577 0.49038,0.86539 0.69231,0.92308c0.11538,0.02884 0.34615,0.02884 0.46154,0c0.02884,0 0.20192,-0.20192 0.23077,-0.23077l0.92308,-0.23077c0.375,-0.11538 0.69231,-0.51923 0.69231,-0.92308c0,-0.14423 0.0577,-0.23077 -0.46154,-1.84615c-0.11538,-0.28846 -0.375,-0.57692 -0.69231,-0.69231c0.0577,-0.17307 0.17308,-0.20192 0.23077,-0.46154l1.15385,1.15385c0.0577,0.0577 0.40385,0.20192 0.46154,0.23077l2.53846,1.38462l0.46154,0.23077l0.23077,0.69231l-1.84615,-0.46154c-0.14423,-0.02884 -0.54808,0.17308 -0.69231,0.23077c-0.28846,0.14423 -0.49038,0.375 -0.46154,0.69231c0.02884,0.23077 0.17308,0.60577 0.23077,0.92308c0.02884,0.11538 -0.08654,0.14423 0,0.23077c0.51923,0.66346 1.35577,1.15385 2.07692,1.61538c0.08654,0.0577 0.17308,0.17308 0.23077,0.23077c-0.46154,0.08654 -0.69231,0.40385 -0.69231,0.92308c-0.08654,-0.34615 -0.17307,-0.63461 -0.23077,-0.92308c-0.02884,-0.17307 -0.11538,-0.34615 -0.23077,-0.46154l-0.69231,-0.46154l-1.15385,-0.69231c-0.17307,-0.08654 -0.28846,-0.23077 -0.46154,-0.23077c-0.08654,0 -0.375,-0.02884 -0.46154,0l-1.15385,0.46154l-6.69231,0.46154c-0.05769,0 -0.17307,-0.02884 -0.23077,0l-4.38462,1.61538h-1.61538c0.0577,-0.05769 -0.02884,-0.17307 0,-0.23077l1.61538,-0.23077c0.08654,0 0.17308,0.02884 0.23077,0h0.23077c0.08654,-0.02884 0.17308,-0.17307 0.23077,-0.23077l1.38462,-1.15385l0.23077,-0.23077c0.20192,-0.23077 0.46154,-0.49038 0.69231,-0.69231c0.20192,-0.20192 0.31731,-0.63461 0.23077,-0.92308l-0.69231,-1.61538l0.23077,-0.46154l0.69231,-0.23077h0.23077c0.08654,0 0.14423,0.02884 0.23077,0c0.02884,0 0.20192,-0.23077 0.23077,-0.23077l0.69231,-0.46154c0.23077,-0.11538 0.43269,-0.23077 0.46154,-0.46154l0.23077,-1.38462v-0.23077l2.07692,0.46154c0.14423,0 0.34615,-0.14423 0.46154,-0.23077zM149.76923,64.15385h0.23077c0.17308,0 0.34615,0.08654 0.46154,0l0.23077,0.23077c0.0577,0.08654 -0.05769,0.17308 0,0.23077c0.0577,0.0577 0.11538,0.14423 0.23077,0.23077c0.11538,0.08654 0.31731,0.20192 0.46154,0.23077l0.92308,1.15385c0.11538,0.14423 0.28847,0.20192 0.46154,0.23077c0.08654,0.02884 0.14423,-0.02884 0.23077,0c0,0.02884 -0.02884,0.20192 0,0.23077c0.17308,0.28847 0.49038,0.57692 0.69231,0.92308l0.23077,0.46154c0.0577,0.11538 0.11538,0.375 0.23077,0.46154h0.23077c0.11538,0.08654 0.31731,0.23077 0.46154,0.23077h0.69231c-0.02884,0.08654 0,0.11538 0,0.23077c0.0577,0.17308 0.02884,0.08654 0.46154,0.92308c0.25961,0.43269 0.20192,0.54808 3.23077,1.15385c0.86539,-0.08654 1.00962,-0.80769 0.92308,-2.07692l0.23077,0.23077c0.17308,0.17308 0.43269,0.28847 0.69231,0.23077l1.38462,-0.46154c0.11538,-0.02884 0.14423,0.0577 0.23077,0h0.23077c-0.11538,0.11538 -0.20192,0.34615 -0.23077,0.46154c-0.05769,0.34615 -0.05769,0.66346 0.23077,0.92308c0.08654,0.0577 0.28847,0.0577 1.38462,0.69231c0.0577,0.02884 -0.05769,0.20192 0,0.23077h0.23077c0.14423,0.02884 0.31731,-0.17307 0.46154,-0.23077c0.11538,-0.05769 0.14423,-0.14423 0.23077,-0.23077l0.46154,-0.46154c0.08654,0.28847 0.14423,0.63462 0.23077,0.92308l-0.23077,3l-1.84615,-0.69231c-0.31731,-0.08654 -0.51923,0.20192 -0.69231,0.46154l-0.69231,0.69231l-2.76923,-1.15385c-0.08654,-0.02884 -0.14423,-0.02884 -0.23077,0c-0.43269,0.02884 -0.80769,0 -1.15385,0l-0.23077,-0.23077c-0.11538,-0.17307 -0.25961,-0.43269 -0.46154,-0.46154c-0.95192,-0.14423 -1.58654,0 -2.30769,0c-0.08654,0 -0.14423,-0.02884 -0.23077,0c-0.05769,0.02884 -0.20192,-0.02884 -0.23077,0l-0.69231,0.46154c-0.17307,0.11538 -0.43269,0.25961 -0.46154,0.46154l-0.23077,1.38462l-3.23077,-1.84615c-0.02884,-0.02884 -0.20192,0.02884 -0.23077,0l-3.46154,-0.92308l-0.92308,-0.46154c0.08654,-0.14423 0,-0.28846 0,-0.46154c-0.05769,-0.72115 -0.14423,-1.24039 -0.23077,-1.84615c0.08654,0.25961 0.31731,0.40385 0.46154,0.69231c0.08654,0.14423 0.14423,0.46154 0.23077,0.69231c0.25961,0.46154 0.57692,0.43269 0.69231,0.46154c0.08654,0.02884 0.14423,0.02884 0.23077,0c0.46154,-0.05769 0.63462,-0.23077 1.38462,-1.38462c0.0577,-0.08654 -0.02884,-0.14423 0,-0.23077c0.02884,-0.11538 0.02884,-0.11538 0,-0.23077c-0.02884,-0.17307 0.08654,-0.34615 0,-0.46154c0.34615,-0.14423 0.43269,-0.51923 0.46154,-0.92308v-1.15385c0.20192,-0.05769 0.375,-0.25961 0.46154,-0.46154l0.69231,-1.38462c0.11538,-0.20192 0.11538,-0.49038 0,-0.69231zM157.15385,66.23077c0.11538,0.14423 0.40385,0.20192 0.46154,0.23077l0.92308,1.61538c-0.40384,-0.02884 -0.98077,-0.20192 -1.38462,-0.23077v-0.23077c0.14423,-0.14423 0.23077,-0.25961 0.23077,-0.46154c0,-0.40384 -0.17307,-0.66346 -0.23077,-0.92308zM23.07692,88.84615c0.0577,0.0577 0.14423,0.17308 0.23077,0.23077v0.23077c-0.08654,0.28847 -0.14423,0.57692 0,1.38462c0.11538,0.34615 0.17308,0.28847 0.46154,0.46154c0.17308,0.11538 0.49038,0.0577 0.69231,0c0.0577,-0.02884 0.17308,0.02884 0.23077,0c-0.08654,0.83654 0.28847,1.64423 0.92308,2.07692c0.28847,0.20192 0.57692,0.46154 0.92308,0.46154c1.00962,0 1.70192,-0.92308 1.84615,-2.07692c0.0577,-0.40384 0.11538,-0.80769 0,-1.15385l0.46154,0.46154c0,0.14423 -0.20192,0.08654 -0.23077,0.23077v0.69231c0.0577,0.40385 0.34615,0.75 0.69231,0.92308h-0.46154c-0.11538,-0.02884 -0.14423,0 -0.23077,0c-0.34615,0.08654 -0.49038,0.08654 -1.15385,0.92308c-0.17307,0.23077 -0.28846,0.63462 -0.23077,0.92308c0.0577,0.25961 0.28847,0.34615 0.46154,0.46154c0.375,0.31731 0.72115,0.69231 1.15385,0.92308l0.46154,0.23077c0.08654,0.0577 0.375,-0.02884 0.46154,0v0.23077c0.08654,0.02884 0.14423,0 0.23077,0c0.0577,-0.02884 0.17308,-0.20192 0.23077,-0.23077l1.38462,-0.46154c0.25961,-0.17307 0.43269,-0.51923 0.46154,-0.92308v-0.46154c0.34615,0.23077 1.125,0.34615 3.23077,0.69231c0.0577,0 0.17308,0 0.23077,0c0.02884,0 0.20192,0 0.23077,0c0.0577,0 0.17308,0 0.23077,0h3.46154c0.17308,0.25961 0.54808,0.43269 0.92308,0.46154h2.30769c0.25961,-0.02884 0.51923,-0.08654 0.69231,-0.23077c0.14423,0.11538 0.28847,0.28847 0.46154,0.46154c0.20192,0.14423 0.46154,0.23077 0.69231,0.23077c0.0577,0 0.17308,0.02884 0.23077,0l0.46154,-0.23077v0.23077c0.0577,0.375 0.31731,0.77885 0.69231,0.92308c-0.08654,0.14423 -0.20192,0.25961 -0.23077,0.46154c0,0.46154 0.23077,0.92308 0.23077,1.38462v0.46154c0.08654,0.54808 0.46154,0.83654 0.69231,0.92308v0.46154c-0.08654,0.14423 -0.23077,0.25961 -0.23077,0.46154c0,0.40385 -0.02884,0.95192 0,1.38462c0.02884,0.28847 0.23077,0.51923 0.46154,0.69231c0,0.23077 -0.02884,0.46154 0,0.69231c-0.11538,0.17308 -0.20192,0.43269 -0.23077,0.69231c0.02884,0.31731 -0.02884,0.60577 0,0.92308v0.23077c0.0577,0.40385 0.40385,0.83654 0.92308,0.92308v0.46154l-1.38462,-1.15385c-0.05769,-0.05769 -0.17307,-0.20192 -0.23077,-0.23077l-2.53846,-0.46154c-0.11538,-0.02884 -0.34615,-0.02884 -0.46154,0h-0.23077l-0.46154,0.23077l-3,-0.69231l-1.61538,-2.07692c-0.05769,-0.08654 -0.14423,-0.20192 -0.23077,-0.23077h-0.23077c-0.25961,-0.14423 -0.69231,-0.23077 -0.92308,0l-0.46154,0.69231l-0.46154,-0.23077c-0.20192,-0.11538 -0.28846,-0.34615 -0.46154,-0.46154c-0.23077,-0.11538 -0.46154,-0.11538 -0.69231,0l-3.46154,1.84615c-0.05769,0.02884 -0.17307,0.17308 -0.23077,0.23077c-0.05769,0.0577 -0.20192,0.14423 -0.23077,0.23077l-0.92308,2.53846l-1.15385,-0.69231c-0.08654,-0.05769 -0.11538,-0.20192 -0.23077,-0.23077h-0.23077c-0.05769,0 -0.20192,0 -0.23077,0l-2.07692,0.46154l-0.69231,-1.38462l0.23077,-6.23077c0.02884,-0.14423 0,-0.31731 0,-0.46154c0,-0.14423 0.0577,-0.11538 0,-0.23077c-0.34615,-0.60577 -0.92308,-1.29808 -1.38462,-1.84615l-0.23077,-0.23077c-0.05769,-0.05769 -0.17307,-0.17307 -0.23077,-0.23077c-0.08654,-0.05769 -0.14423,-0.20192 -0.23077,-0.23077l-1.84615,-0.23077v-1.61538zM32.07692,92.53846c0,0.0577 0,0.20192 0,0.23077c-0.17307,0.23077 -0.23077,0.43269 -0.23077,0.69231c-0.11538,-0.14423 -0.31731,-0.20192 -0.46154,-0.23077c-0.51923,-0.14423 -1.00962,-0.34615 -1.61538,-0.46154zM173.76923,94.38462c0.40385,0.89423 0.80769,1.73077 1.15385,2.53846v1.84615c-0.08654,-0.14423 -0.28846,-0.17307 -0.46154,-0.23077l-0.46154,-3v-0.23077zM13.15385,97.61538l0.46154,0.46154c0.23077,0.23077 0.63462,0.375 0.92308,0.23077l0.92308,-0.69231l0.69231,1.84615c0,0.02884 0,0.20192 0,0.23077c0.02884,0.08654 0.17308,0.17308 0.23077,0.23077l0.46154,0.69231c0.02884,0.0577 -0.05769,0.20192 0,0.23077l0.92308,0.92308c0.0577,0.02884 0.40385,0.20192 0.46154,0.23077l1.15385,0.69231l1.84615,5.53846c0.02884,0.02884 -0.02884,0.20192 0,0.23077l0.46154,0.46154c0.20192,0.23077 0.63462,0.375 0.92308,0.23077l0.23077,-0.23077l0.69231,0.92308c0.0577,0.17308 0.0577,0.375 0.23077,0.46154c0.14423,0.08654 0.34615,0.17308 0.46154,0.23077c0.08654,0.02884 0.17308,-0.02884 0.23077,0l0.92308,1.38462c0.17308,0.25961 0.60577,0.375 0.92308,0.23077l0.92308,-0.46154c0.14423,-0.05769 0.375,-0.31731 0.46154,-0.46154l0.23077,0.69231c0.28847,2.01923 0.75,3.98077 1.15385,6l-0.23077,1.38462l-0.46154,1.38462l-0.46154,3c-0.02884,0.08654 -0.02884,0.14423 0,0.23077c0,0.02884 0,0.20192 0,0.23077c0.17308,0.69231 0.25961,1.41346 0.46154,2.07692l0.23077,0.23077c0.02884,0.11538 -0.08654,0.14423 0,0.23077c0.0577,0.0577 0.28847,0.08654 0.46154,0.23077l-0.23077,0.23077c-0.08654,0.14423 -0.02884,0.28847 0,0.46154c0,0.0577 0.20192,0.17308 0.23077,0.23077l1.38462,3.23077c0.02884,0.0577 -0.05769,0.17308 0,0.23077l3,2.53846l1.38462,2.07692c0.02884,0.0577 0.20192,0.20192 0.23077,0.23077c0.0577,0.08654 0,0.23077 0,0.23077c2.19231,2.88462 5.42308,6.75 6,7.15385l4.15385,2.07692c0.375,0.23077 0.77885,0.40385 2.07692,1.15385l0.46154,0.46154c1.58654,2.42308 3.86539,5.91346 5.76923,8.53846c4.21154,5.33654 5.25,6.86539 10.61538,12.23077c0.02884,0.02884 0.20192,-0.02884 0.23077,0l1.38462,1.15385c0.20192,0.20192 0.49038,0.25961 0.69231,0.46154l0.23077,0.46154c0.0577,0.0577 0.17308,-0.02884 0.23077,0c0.28847,0.17308 0.60577,0.375 0.92308,0.46154c0.0577,0.25961 0.20192,0.31731 1.38462,1.15385c0.20192,0.14423 0.46154,0.23077 0.69231,0.23077l0.46154,0.69231c0.08654,0.11538 0.08654,0.17308 0.23077,0.23077l0.92308,0.46154l0.23077,0.23077c0.0577,0.08654 0.14423,0.17308 0.23077,0.23077c0.40385,0.25961 0.92308,0.31731 1.38462,0.46154l0.23077,0.23077c0.0577,0.23077 0.28847,0.34615 0.46154,0.46154c0.08654,0.08654 0.17308,0.20192 0.23077,0.23077c0.14423,0.08654 0.25961,0.17308 0.46154,0.23077l0.69231,0.46154c0.11538,0.0577 0.34615,0.23077 0.46154,0.23077h0.46154c0.02884,0.02884 0.20192,0.20192 0.23077,0.23077h0.46154c0.08654,0.17308 0.28847,0.375 0.46154,0.46154c-36.375,-8.27885 -63.63461,-40.41346 -64.38462,-79.15385zM178.38462,102.69231c-0.02884,0.28847 0.02884,0.63462 0,0.92308l-0.23077,0.23077c-0.375,0.25961 -0.77885,0.43269 -1.15385,0.69231l-0.23077,-0.23077v-0.46154c0.08654,-0.02884 0.17308,-0.20192 0.23077,-0.23077c0.0577,-0.02884 0.20192,0.02884 0.23077,0zM138.69231,119.07692c-1.06731,0.14423 -1.875,0.89423 -2.07692,1.84615c-0.17307,0.77885 0.0577,1.41346 0.69231,1.84615c0.34615,0.23077 0.72115,0.46154 1.15385,0.46154c1.06731,0 2.04808,-0.86538 2.30769,-1.84615c0.17308,-0.54808 0.11538,-1.15385 -0.23077,-1.61538c-0.34615,-0.49038 -0.89423,-0.69231 -1.61538,-0.69231c-0.02884,0 -0.20192,0 -0.23077,0zM175.38462,119.53846c-1.78846,6.08654 -4.09615,11.88462 -7.15385,17.30769c-0.11538,0.08654 -0.02884,0.11538 -0.69231,0.92308c0.11538,-0.46154 -0.25961,-0.80769 -0.46154,-0.92308c-0.05769,-0.02884 -0.17307,-0.20192 -0.23077,-0.23077c-0.23077,-0.05769 -0.46154,0 -0.69231,0h-0.23077l0.23077,-0.46154c0.11538,-0.23077 0.11538,-0.43269 0.23077,-0.69231l0.23077,-0.46154c0.0577,-0.08654 0.23077,-0.11538 0.23077,-0.23077v-0.46154l0.92308,-3l0.23077,-0.92308l0.92308,-1.61538l0.46154,-0.46154c0.0577,-0.05769 0.20192,-0.14423 0.23077,-0.23077c0.31731,-0.75 0.34615,-1.21153 0.46154,-1.61538l0.92308,-1.61538l0.69231,-0.69231c0.11538,-0.05769 0.14423,-0.11538 0.23077,-0.23077l2.76923,-4.15385zM164.76923,139.61538c0.17308,0.11538 0.28847,-0.02884 0.46154,0c0.0577,0.02884 0.17308,0 0.23077,0c0.11538,-0.02884 0.375,0.08654 0.46154,0c-0.34615,0.43269 -0.92308,0.80769 -1.38462,1.38462l-1.15385,0.69231z"></path></g></g></g></svg></div> <?php echo $page_Lang['show_post_everyone'][$dataUserPageLanguage];?></div>
                   <div class="who_see_item hvr-underline-from-center" id="2" data-ic="onlyme" data-nm="<?php echo $page_Lang['show_just_me'][$dataUserPageLanguage];?>"><div class="w-see" style="padding:2px;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="30" height="30" viewBox="0 0 192 192" style=" fill:#000000;"><g fill="none" fill-rule="nonzero" stroke="none" stroke-width="1" stroke-linecap="butt" stroke-linejoin="miter" stroke-miterlimit="10" stroke-dasharray="" stroke-dashoffset="0" font-family="none" font-weight="none" font-size="none" text-anchor="none" style="mix-blend-mode: normal"><path d="M0,192v-192h192v192z" fill="none"></path><g fill="#8a99a4"><path d="M96,16c-44.112,0 -80,35.888 -80,80c0,44.112 35.888,80 80,80c44.112,0 80,-35.888 80,-80c0,-44.112 -35.888,-80 -80,-80zM96,48c13.6,0 24,10.4 24,24v8c4.8,0 8,3.2 8,8v32c0,4.8 -3.2,8 -8,8h-48c-4.8,0 -8,-3.2 -8,-8v-32c0,-4.8 3.2,-8 8,-8v-8c0,-13.6 10.4,-24 24,-24zM96,60c-6.4,0 -12,5.6 -12,12v8h12h12v-8c0,-6.4 -5.6,-12 -12,-12zM96,96c-4.41828,0 -8,3.58172 -8,8c0,4.41828 3.58172,8 8,8c4.41828,0 8,-3.58172 8,-8c0,-4.41828 -3.58172,-8 -8,-8z"></path></g></g></svg></div> <?php echo $page_Lang['show_just_me'][$dataUserPageLanguage];?></div>
                   <div class="who_see_item hvr-underline-from-center" id="3" data-ic="friends" data-nm="<?php echo $page_Lang['show_just_friends'][$dataUserPageLanguage];?>"><div class="w-see"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="24" height="24" viewBox="0 0 192 192" style=" fill:#000000;"><g fill="none" fill-rule="nonzero" stroke="none" stroke-width="1" stroke-linecap="butt" stroke-linejoin="miter" stroke-miterlimit="10" stroke-dasharray="" stroke-dashoffset="0" font-family="none" font-weight="none" font-size="none" text-anchor="none" style="mix-blend-mode: normal"><path d="M0,192v-192h192v192z" fill="none"></path><g fill="#8a99a4"><path d="M60.425,19.2c-34.8864,0.6016 -38.4516,24.7926 -31.45,52.575c-1.3568,0.7808 -3.5882,3.2593 -3.025,7.6625c1.0496,8.2112 4.6094,10.2897 6.875,10.4625c0.864,7.6672 9.095,17.4728 11.975,18.9v12.8c-6.4,19.2 -44.8,0 -44.8,51.2h76.8c0,-22.7072 12.7324,-32.4869 23.35,-38.1125c-9.9712,-3.4944 -20.2972,-3.9291 -23.35,-13.0875v-12.8c2.88,-1.4272 11.1046,-11.2267 11.975,-18.8875c0.512,-1.8112 0.9125,-8.2908 0.9125,-9.75c0,-7.9936 -0.1173,-24.5156 4.8875,-37.45c-1.7472,-8.6912 -6.3144,-16.0211 -16.1,-16.9875c-2.6176,-4.3328 -9.3268,-6.525 -18.05,-6.525zM141.5875,25.6c-7.1936,0 -12.75,6.4 -12.75,6.4c-41.2288,0 -18.3412,70.1014 -30.45,80.175c0,0 6.4381,9.5375 29.6125,9.5375v8.1625c-6.4,17.3248 -38.4,10.925 -38.4,42.925h102.4c0,-32 -32,-25.6002 -38.4,-42.925v-8.2375c23.2896,0 28.6875,-9.225 28.6875,-9.225c-13.0368,-10.7008 9.7064,-86.8125 -40.7,-86.8125z"></path></g></g></svg></div> <?php echo $page_Lang['show_just_friends'][$dataUserPageLanguage];?></div>
               </div>
           </div>
           <!--header finished-->
           <!--Input and textarea STARTED-->
           <div class="write_post_information">
               <!--Input STARTED-->
               <div class="global_post_box">
                   <input type="text" class="title" id="place" placeholder="<?php echo $page_Lang['where_are_you_know'][$dataUserPageLanguage]; echo $dataUserFullName?>" value="" >
               </div>
               <!--Input FINISHED-->
               <!--Textarea STARTED-->
               <div class="global_post_box">
                  <textarea class="description" id="aboutplace" placeholder="<?php echo $page_Lang['write_something_about_your_place'][$dataUserPageLanguage];?>"></textarea>
               </div>
               <!--Textarea FINISHED-->
               <!--Hashtag STARTED-->
               <div class="global_post_box">
                  <input class="hashtag_" id="hashTag" placeholder="<?php echo $page_Lang['post_tag'][$dataUserPageLanguage];?>" >
               </div>
               <input type="hidden" id="lati" />
               <input type="hidden" id="longi" />
               <!--Hashtag FINISHED-->
               <div class="global_post_box">
                    <div class="feeling-activity"></div>
               </div>
               <div class="global_post_box mapif">
                  
               </div>
           </div>
           <!--Input and Textarea FINISHED-->
           <!--Post Footer STARTED-->
             <div class="post_box_footer">
             <input type="hidden" id="f_val" />
                  <div class="control left_btn"><div class="close_post_box waves-effect waves-light btn blue-grey lighten-3" id="closePost"><?php echo $page_Lang['post_cancel'][$dataUserPageLanguage];?></div></div>
                  <div class="control right_btn"><div class="share_post_box waves-effect waves-light btn blue  share_event_location" id="thisup" data-type="myEventLocation"><?php echo $page_Lang['post_share'][$dataUserPageLanguage];?></div></div>
             </div>  
           <!--Post Footer FINISHED-->
       </div>
   </div>
</div> 
<script type="text/javascript">
$(document).ready(function() {
  function getLocation() {
    if (navigator.geolocation) {
      navigator.geolocation.getCurrentPosition(showPosition);
    } else {
      x.innerHTML = "Geolocation is not supported by this browser.";
    }
  }
  getLocation();
  function showPosition(position) {
    $(".mapif").html(
      '<iframe src="https://maps.google.com/maps?q=' +
        position.coords.latitude +
        "," +
        position.coords.longitude +
        '&z=12&output=embed" width="100%" height="270" frameborder="0" style="border:0"></iframe>'
    );
	$("#lati").val(position.coords.latitude);
	$("#longi").val(position.coords.longitude);
    var latitude = position.coords.latitude;
    var longitude = position.coords.longitude;
    var url =
      "https://maps.googleapis.com/maps/api/geocode/json?latlng=" +
      latitude +
      "," +
      longitude +
      "&sensor=true&key=<?php echo $dot_googleMapApi;?>";
    $.ajax({
      url: url,
      success: function(data) {
        $("#place").val(data.results[0].formatted_address);
        /*or you could iterate the components for only the city and state*/
      }
    });
  }
}); 
</script>

 